searchData={"content_type":"text/markdown","items":[{"doc":"Serialize the given OpenApi spec module to a JSON file.","ref":"Mix.Tasks.Openapi.Spec.Json.html","title":"mix openapi.spec.json","type":"task"},{"doc":"$ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec apispec.json\n    $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --pretty=true\n    $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --check=true\n    $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --start-app=false\n    $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --vendor-extensions=false","ref":"Mix.Tasks.Openapi.Spec.Json.html#module-examples","title":"Examples - mix openapi.spec.json","type":"task"},{"doc":"* `--spec` - The ApiSpec module from which to generate the OpenAPI JSON file\n\n* `--pretty` - Whether to prettify the generated JSON (defaults to false)\n\n* `--check` - Whether to only compare the generated JSON with the spec file (defaults to false)\n\n* `--start-app` - Whether need to start application before generate schema (defaults to true)\n\n* `--vendor-extensions` - Whether to include open_api_spex OpenAPI vendor extensions\n  (defaults to true)\n\n* `--quiet` - Whether to disable output printing (defaults to false)\n\n* `--filename` - The output filename (defaults to \"openapi.json\")","ref":"Mix.Tasks.Openapi.Spec.Json.html#module-command-line-options","title":"Command line options - mix openapi.spec.json","type":"task"},{"doc":"Serialize the given OpenApi spec module to a YAML file.","ref":"Mix.Tasks.Openapi.Spec.Yaml.html","title":"mix openapi.spec.yaml","type":"task"},{"doc":"$ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec apispec.yaml\n    $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec --check=true\n    $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec --start-app=false\n    $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec --vendor-extensions=false","ref":"Mix.Tasks.Openapi.Spec.Yaml.html#module-examples","title":"Examples - mix openapi.spec.yaml","type":"task"},{"doc":"* `--spec` - The ApiSpec module from which to generate the OpenAPI YAML file\n\n* `--check` - Whether to only compare the generated YAML with the spec file (defaults to false)\n\n* `--start-app` - Whether to start the application before generating the schema (defaults to true)\n\n* `--vendor-extensions` - Whether to include open_api_spex OpenAPI vendor extensions\n  (defaults to true)\n\n* `--quiet` - Whether to disable output printing (defaults to false)\n\n* `--filename` - The output filename (defaults to \"openapi.yaml\")","ref":"Mix.Tasks.Openapi.Spec.Yaml.html#module-command-line-options","title":"Command line options - mix openapi.spec.yaml","type":"task"},{"doc":"Provides the entry-points for defining schemas, validating and casting.","ref":"OpenApiSpex.html","title":"OpenApiSpex","type":"module"},{"doc":"","ref":"OpenApiSpex.html#add_parameter_content_parser/3","title":"OpenApiSpex.add_parameter_content_parser/3","type":"function"},{"doc":"Add more schemas to an existing OpenApi struct.\n\nThis is useful when the schemas are not used by a Plug or Controller.\nPerhaps they're used by a Phoenix Channel.","ref":"OpenApiSpex.html#add_schemas/2","title":"OpenApiSpex.add_schemas/2","type":"function"},{"doc":"defmodule MyAppWeb.ApiSpec do\n      def spec do\n        %OpenApiSpex.OpenApi{\n          # ...\n          paths: OpenApiSpex.Paths.from_router(MyAppWeb.Router)\n          # ...\n        }\n        |> OpenApiSpex.resolve_schema_modules()\n        |> OpenApiSpex.add_schemas([\n          MyAppWeb.Schemas.Message,\n          MyAppWeb.Schemas.Channel\n        ])\n      end\n    end","ref":"OpenApiSpex.html#add_schemas/2-example","title":"Example - OpenApiSpex.add_schemas/2","type":"function"},{"doc":"Get casted body params from a `Plug.Conn`.\nIf the conn has not been yet casted `nil` is returned.","ref":"OpenApiSpex.html#body_params/1","title":"OpenApiSpex.body_params/1","type":"function"},{"doc":"Build a Schema struct from the given keyword list.\n\nThis function adds functionality over defining a\nschema with struct literal sytax using `%OpenApiSpex.Struct{}`:\n\n- When the `:module` option is given, the `:\"x-struct` and `:title`\n  attributes of the schema will be autopopulated based on the given\n  module\n- Validations are performed on the schema to ensure it is correct.","ref":"OpenApiSpex.html#build_schema/2","title":"OpenApiSpex.build_schema/2","type":"function"},{"doc":"- `:module` (module) - A module in the application that the schema\n  should be associated with.","ref":"OpenApiSpex.html#build_schema/2-options","title":"Options - OpenApiSpex.build_schema/2","type":"function"},{"doc":"Cast params to conform to a `OpenApiSpex.Schema`.\n\nSee `OpenApiSpex.Schema.cast/3` for additional examples and details.","ref":"OpenApiSpex.html#cast/3","title":"OpenApiSpex.cast/3","type":"function"},{"doc":"Cast all params in `Plug.Conn` to conform to the schemas for `OpenApiSpex.Operation`.\n\nReturns `{:ok, Plug.Conn.t}` with `params` and `body_params` fields updated if successful,\nor `{:error, reason}` if casting fails.\n\n`content_type` may optionally be supplied to select the `requestBody` schema.","ref":"OpenApiSpex.html#cast/4","title":"OpenApiSpex.cast/4","type":"function"},{"doc":"","ref":"OpenApiSpex.html#cast_and_validate/5","title":"OpenApiSpex.cast_and_validate/5","type":"function"},{"doc":"Cast and validate a value against a given Schema.","ref":"OpenApiSpex.html#cast_value/2","title":"OpenApiSpex.cast_value/2","type":"function"},{"doc":"Cast and validate a value against a given Schema belonging to a given OpenApi spec.","ref":"OpenApiSpex.html#cast_value/4","title":"OpenApiSpex.cast_value/4","type":"function"},{"doc":"Raises compile time errors for improperly defined schemas.","ref":"OpenApiSpex.html#error!/3","title":"OpenApiSpex.error!/3","type":"function"},{"doc":"","ref":"OpenApiSpex.html#error_message/1","title":"OpenApiSpex.error_message/1","type":"function"},{"doc":"Get casted params from a `Plug.Conn`.\nIf the conn has not been yet casted `nil` is returned.","ref":"OpenApiSpex.html#params/1","title":"OpenApiSpex.params/1","type":"function"},{"doc":"","ref":"OpenApiSpex.html#path_to_string/1","title":"OpenApiSpex.path_to_string/1","type":"function"},{"doc":"Resolve a schema or reference to a schema.","ref":"OpenApiSpex.html#resolve_schema/2","title":"OpenApiSpex.resolve_schema/2","type":"function"},{"doc":"Adds schemas to the api spec from the modules specified in the Operations.\n\nEg, if the response schema for an operation is defined with:\n\n    responses: %{\n      200 => Operation.response(\"User\", \"application/json\", UserResponse)\n    }\n\nThen the `UserResponse.schema()` function will be called to load the schema, and\na `Reference` to the loaded schema will be used in the operation response.\n\nSee `OpenApiSpex.schema` macro for a convenient syntax for defining schema modules.","ref":"OpenApiSpex.html#resolve_schema_modules/1","title":"OpenApiSpex.resolve_schema_modules/1","type":"function"},{"doc":"Declares a struct based `OpenApiSpex.Schema`\n\n - defines the schema/0 callback\n - ensures the schema is linked to the module by \"x-struct\" extension property\n - defines a struct with keys matching the schema properties\n - defines a @type `t` for the struct\n - derives a `Jason.Encoder` and/or `Poison.Encoder` for the struct\n\nSee `OpenApiSpex.Schema` for additional examples and details.","ref":"OpenApiSpex.html#schema/2","title":"OpenApiSpex.schema/2","type":"macro"},{"doc":"require OpenApiSpex\n\n    defmodule User do\n      OpenApiSpex.schema %{\n        title: \"User\",\n        description: \"A user of the app\",\n        type: :object,\n        properties: %{\n          id: %Schema{type: :integer, description: \"User ID\"},\n          name:  %Schema{type: :string, description: \"User name\", pattern: ~r/[a-zA-Z][a-zA-Z0-9_]+/},\n          email: %Schema{type: :string, description: \"Email address\", format: :email},\n          inserted_at: %Schema{type: :string, description: \"Creation timestamp\", format: :'date-time'},\n          updated_at: %Schema{type: :string, description: \"Update timestamp\", format: :'date-time'}\n        },\n        required: [:name, :email],\n        example: %{\n          \"id\" => 123,\n          \"name\" => \"Joe User\",\n          \"email\" => \"joe@gmail.com\",\n          \"inserted_at\" => \"2017-09-12T12:34:55Z\",\n          \"updated_at\" => \"2017-09-13T10:11:12Z\"\n        }\n      }\n    end","ref":"OpenApiSpex.html#schema/2-example","title":"Example - OpenApiSpex.schema/2","type":"macro"},{"doc":"This example shows the `:struct?` and `:derive?` options that may\nbe passed to `schema/2`:\n\n    defmodule MyAppWeb.Schemas.User do\n      require OpenApiSpex\n      alias OpenApiSpex.Schema\n\n      OpenApiSpex.schema(\n        %{\n          type: :object,\n          properties: %{\n            name: %Schema{type: :string}\n          }\n        },\n        struct?: false,\n        derive?: false\n      )\n    end","ref":"OpenApiSpex.html#schema/2-example","title":"Example - OpenApiSpex.schema/2","type":"macro"},{"doc":"- `:struct?` (boolean) - When false, prevents the automatic generation\n  of a struct definition for the schema module.\n- `:derive?` (boolean) When false, prevents the automatic generation\n  of a `@derive` call for either `Poison.Encoder`\n  or `Jason.Encoder`. Using this option can\n  prevent \"... protocol has already been consolidated ...\"\n  compiler warnings.","ref":"OpenApiSpex.html#schema/2-options","title":"Options - OpenApiSpex.schema/2","type":"macro"},{"doc":"Creates an `%OpenApi{}` struct from a map.\n\nThis is useful when importing existing JSON or YAML encoded schemas.","ref":"OpenApiSpex.html#schema_from_map/1","title":"OpenApiSpex.schema_from_map/1","type":"function"},{"doc":"# Importing an existing JSON encoded schema\n    open_api_spec_from_json = \"encoded_schema.json\"\n      |> File.read!()\n      |> Jason.decode!()\n      |> OpenApiSpex.OpenApi.Decode.decode()\n\n    # Importing an existing YAML encoded schema\n    open_api_spec_from_yaml = \"encoded_schema.yaml\"\n      |> YamlElixir.read_all_from_file!()\n      |> OpenApiSpex.OpenApi.Decode.decode()","ref":"OpenApiSpex.html#schema_from_map/1-example","title":"Example - OpenApiSpex.schema_from_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.html#title_from_module/1","title":"OpenApiSpex.title_from_module/1","type":"function"},{"doc":"Validate params against `OpenApiSpex.Schema`.\n\nSee `OpenApiSpex.Schema.validate/3` for examples of error messages.","ref":"OpenApiSpex.html#validate/3","title":"OpenApiSpex.validate/3","type":"function"},{"doc":"Validate all params in `Plug.Conn` against `OpenApiSpex.Operation` `parameter` and `requestBody` schemas.\n\n`content_type` may be optionally supplied to select the `requestBody` schema.","ref":"OpenApiSpex.html#validate/4","title":"OpenApiSpex.validate/4","type":"function"},{"doc":"Validate the compiled schema's properties to ensure the schema is not improperly\ndefined. Only errors which would cause a given schema to _always_ fail should be\nraised here.","ref":"OpenApiSpex.html#validate_compiled_schema/1","title":"OpenApiSpex.validate_compiled_schema/1","type":"function"},{"doc":"Used for validating the schema at compile time, otherwise we're forced\nto raise errors for improperly defined schemas at runtime.","ref":"OpenApiSpex.html#validate_compiled_schema/2","title":"OpenApiSpex.validate_compiled_schema/2","type":"function"},{"doc":"","ref":"OpenApiSpex.html#t:cast_opt/0","title":"OpenApiSpex.cast_opt/0","type":"type"},{"doc":"","ref":"OpenApiSpex.html#t:read_write_scope/0","title":"OpenApiSpex.read_write_scope/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Callback.t` type.","ref":"OpenApiSpex.Callback.html","title":"OpenApiSpex.Callback","type":"module"},{"doc":"[Callback Object](https://swagger.io/specification/#callbackObject)\n\nA map of possible out-of band callbacks related to the parent operation.\nEach value in the map is a Path Item Object that describes a set of requests\nthat may be initiated by the API provider and the expected responses.\nThe key value used to identify the callback object is an expression, evaluated at runtime,\nthat identifies a URL to use for the callback operation.","ref":"OpenApiSpex.Callback.html#t:t/0","title":"OpenApiSpex.Callback.t/0","type":"type"},{"doc":"Cast and validate a value against an OpenApiSpex schema","ref":"OpenApiSpex.Cast.html","title":"OpenApiSpex.Cast","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.html#cast/1","title":"OpenApiSpex.Cast.cast/1","type":"function"},{"doc":"Cast and validate a value against the given schema.\n\nRecognizes all the types defined in Open API (itself a superset of JSON Schema).\n\nJSON Schema types:\n[https://json-schema.org/latest/json-schema-core.html#rfc.section.4.2.1](https://json-schema.org/latest/json-schema-core.html#rfc.section.4.2.1)\n\nOpen API primitive types:\n[https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.0.md#data-types](https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.0.md#data-types)\n\nFor an `:object` schema type, the cast operation returns a map with atom keys.","ref":"OpenApiSpex.Cast.html#cast/4","title":"OpenApiSpex.Cast.cast/4","type":"function"},{"doc":"iex> alias OpenApiSpex.{Cast, Schema}\n    iex> schema = %Schema{type: :string}\n    iex> Cast.cast(schema, \"a string\")\n    {:ok, \"a string\"}\n    iex> Cast.cast(schema, 1..100)\n    {\n      :error,\n      [\n        %OpenApiSpex.Cast.Error{\n          reason: :invalid_type,\n          type: :string,\n          value: 1..100\n        }\n      ]\n    }\n    iex> schema = %Schema{\n    ...>    type: :object,\n    ...>    properties: %{\n    ...>      name: nil\n    ...>    },\n    ...>    additionalProperties: false\n    ...> }\n    iex> Cast.cast(schema, %{\"name\" => \"spex\"})\n    {:ok, %{name: \"spex\"}}\n    iex> Cast.cast(schema, %{\"bad\" => \"spex\"})\n    {\n      :error,\n      [\n        %OpenApiSpex.Cast.Error{\n          name: \"bad\",\n          path: [\"bad\"],\n          reason: :unexpected_field,\n          value: %{\"bad\" => \"spex\"}\n        }\n      ]\n    }","ref":"OpenApiSpex.Cast.html#cast/4-examples","title":"Examples - OpenApiSpex.Cast.cast/4","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#error/2","title":"OpenApiSpex.Cast.error/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#ok/1","title":"OpenApiSpex.Cast.ok/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#success/2","title":"OpenApiSpex.Cast.success/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:cast_opt/0","title":"OpenApiSpex.Cast.cast_opt/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:read_write_scope/0","title":"OpenApiSpex.Cast.read_write_scope/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:schema_or_reference/0","title":"OpenApiSpex.Cast.schema_or_reference/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:t/0","title":"OpenApiSpex.Cast.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Discriminator.t` type.","ref":"OpenApiSpex.Cast.Discriminator.html","title":"OpenApiSpex.Cast.Discriminator","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.Discriminator.html#cast/1","title":"OpenApiSpex.Cast.Discriminator.cast/1","type":"function"},{"doc":"[Discriminator Object](https://swagger.io/specification/#discriminatorObject)\n\nWhen request bodies or response payloads may be one of a number of different schemas,\na discriminator object can be used to aid in serialization, deserialization, and validation.\nThe discriminator is a specific object in a schema which is used to inform the consumer of the\nspecification of an alternative schema based on the value associated with it.\n\nA discriminator requires a composite key be set on the schema:\n\n  * `allOf`\n  * `oneOf`\n  * `anyOf`","ref":"OpenApiSpex.Cast.Discriminator.html#t:t/0","title":"OpenApiSpex.Cast.Discriminator.t/0","type":"type"},{"doc":"OpenApiSpex Cast Error","ref":"OpenApiSpex.Cast.Error.html","title":"OpenApiSpex.Cast.Error","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#message/1","title":"OpenApiSpex.Cast.Error.message/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#message_with_path/1","title":"OpenApiSpex.Cast.Error.message_with_path/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#new/2","title":"OpenApiSpex.Cast.Error.new/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#path_to_string/1","title":"OpenApiSpex.Cast.Error.path_to_string/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:all_of_error/0","title":"OpenApiSpex.Cast.Error.all_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:any_of_error/0","title":"OpenApiSpex.Cast.Error.any_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:args/0","title":"OpenApiSpex.Cast.Error.args/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:custom_error/0","title":"OpenApiSpex.Cast.Error.custom_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:exclusive_max_error/0","title":"OpenApiSpex.Cast.Error.exclusive_max_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:exclusive_min_error/0","title":"OpenApiSpex.Cast.Error.exclusive_min_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_discriminator_value_error/0","title":"OpenApiSpex.Cast.Error.invalid_discriminator_value_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_enum_error/0","title":"OpenApiSpex.Cast.Error.invalid_enum_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_format_error/0","title":"OpenApiSpex.Cast.Error.invalid_format_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_header_error/0","title":"OpenApiSpex.Cast.Error.invalid_header_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_schema_error/0","title":"OpenApiSpex.Cast.Error.invalid_schema_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_type_error/0","title":"OpenApiSpex.Cast.Error.invalid_type_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:max_items_error/0","title":"OpenApiSpex.Cast.Error.max_items_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:max_length_error/0","title":"OpenApiSpex.Cast.Error.max_length_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:max_properties_error/0","title":"OpenApiSpex.Cast.Error.max_properties_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:maximum_error/0","title":"OpenApiSpex.Cast.Error.maximum_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:min_items_error/0","title":"OpenApiSpex.Cast.Error.min_items_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:min_length_error/0","title":"OpenApiSpex.Cast.Error.min_length_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:min_properties_error/0","title":"OpenApiSpex.Cast.Error.min_properties_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:minimum_error/0","title":"OpenApiSpex.Cast.Error.minimum_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:missing_field_error/0","title":"OpenApiSpex.Cast.Error.missing_field_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:missing_header_error/0","title":"OpenApiSpex.Cast.Error.missing_header_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:multiple_of_error/0","title":"OpenApiSpex.Cast.Error.multiple_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:no_value_for_discriminator_error/0","title":"OpenApiSpex.Cast.Error.no_value_for_discriminator_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:null_value_error/0","title":"OpenApiSpex.Cast.Error.null_value_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:one_of_error/0","title":"OpenApiSpex.Cast.Error.one_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:reason/0","title":"OpenApiSpex.Cast.Error.reason/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:t/0","title":"OpenApiSpex.Cast.Error.t/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:unexpected_field_error/0","title":"OpenApiSpex.Cast.Error.unexpected_field_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:unique_items_error/0","title":"OpenApiSpex.Cast.Error.unique_items_error/0","type":"type"},{"doc":"This module will cast a binary to either an Elixir DateTime or Date. Otherwise it will\nvalidate a binary based on maxLength, minLength, or a Regex pattern passed through the\nschema struct.","ref":"OpenApiSpex.Cast.String.html","title":"OpenApiSpex.Cast.String","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.String.html#cast/1","title":"OpenApiSpex.Cast.String.cast/1","type":"function"},{"doc":"Defines the `OpenApiSpex.Components.t` type.","ref":"OpenApiSpex.Components.html","title":"OpenApiSpex.Components","type":"module"},{"doc":"","ref":"OpenApiSpex.Components.html#t:responses_map/0","title":"OpenApiSpex.Components.responses_map/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Components.html#t:schemas_map/0","title":"OpenApiSpex.Components.schemas_map/0","type":"type"},{"doc":"[Components Object](https://swagger.io/specification/#componentsObject)\n\nHolds a set of reusable objects for different aspects of the OAS.\nAll objects defined within the components object will have no effect on the API unless\nthey are explicitly referenced from properties outside the components object.","ref":"OpenApiSpex.Components.html#t:t/0","title":"OpenApiSpex.Components.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Contact.t` type.","ref":"OpenApiSpex.Contact.html","title":"OpenApiSpex.Contact","type":"module"},{"doc":"[Contact Object](https://swagger.io/specification/#contactObject)\n\nContact information for the exposed API.","ref":"OpenApiSpex.Contact.html#t:t/0","title":"OpenApiSpex.Contact.t/0","type":"type"},{"doc":"Generation of OpenAPI documentation via ExDoc documentation and tags.\n\nNote: For projects using Elixir releases, [there is an issue](https://github.com/open-api-spex/open_api_spex/issues/242) that\npotentially breaks OpenApiSpex's integration with your application. Please use `OpenApiSpex.ControllerSpecs` instead.","ref":"OpenApiSpex.Controller.html","title":"OpenApiSpex.Controller","type":"module"},{"doc":"### `description` and `summary`\n\nDescription of endpoint will be filled with documentation string in the same\nmanner as ExDocs, so first line will be used as a `summary` and the rest of it\nwill be used as `description` field.\n\n### `operation_id`\n\nThe action's `operation_id` can be set explicitly using a `@doc` tag.\nIf no `operation_id` is specified, it will default to the action's module path: `Module.Name.function_name`\n\n### `parameters`\n\nParameters of the endpoint are defined by `:parameters` tag which should be\nmap or list that is formed as:\n\n```elixir\n[\n  param_name: definition\n]\n\n# or\n\n[\n  structure_definition\n]\n```\n\nWhere `definition` is map or keyword list that accepts the same arguments.\nWhere `structure_definition` is `OpenApiSpex.Parameter.t()` or `OpenApiSpex.Reference.t()` structure\nthat accepts the same arguments.\n\nExample:\n\n```elixir\n@doc parameters: [\n  group_id: [in: :path, type: :integer, description: \"Group ID\", example: 1]\n]\n```\n\nor\n\n```elixir\n@doc parameters: [\n  %OpenApiSpex.Parameter{\n    in: :path,\n    name: :group_id,\n    description: \"Group ID\",\n    schema: %Schema{type: :integer},\n    required: true,\n    example: 1\n  }\n]\n```\n\nor\n\n```elixir\n@doc parameters: [\n  \"$ref\": \"#/components/parameters/group_id\"\n  # or\n  %OpenApiSpex.Reference{\"$ref\": \"#/components/parameters/group_id\"}\n]\n```\n\n### `responses`\n\nResponses are controlled by `:responses` tag. Responses must be defined as\na map or keyword list in form of:\n\n```\n%{\n  200 => {\"Response name\", \"application/json\", schema},\n  :not_found => {\"Response name\", \"application/json\", schema}\n}\n```\n\nOr:\n```\n[\n  ok: {\"Response name\", \"application/json\", schema},\n  not_found: {\"Response name\", \"application/json\", schema}\n]\n```\n\nIf a response has no body, the definition may be simplified further:\n\n```\n[\n  no_content: \"Empty response\"\n]\n```\n\nFor each key in the key-value list of map, either an HTTP status code can be used or its atom equivalent.\n\nThe full set of atom keys are defined in `Plug.Conn.Status.code/1`.\n\n### `requestBody`\n\nControlled by `:request_body` parameter and is defined as a tuple in form\n`{description, mime, schema}` or `{description, mime, schema, opts}` that\nmatches the arguments of `OpenApiSpex.Operation.request_body/3` or\n`OpenApiSpex.Operation.request_body/4`, respectively.\n\n```\n@doc request_body: {\n  \"CartUpdateRequest\",\n  \"application/vnd.api+json\",\n  CartUpdateRequest,\n  required: true\n}\n```\n\n### `security`\n\nAllows specifying the security scheme(s) required for this operation.  See\n`OpenApiSpex.Operation` and `OpenApiSpex.SecurityRequirement`.\n\n### `tags`\n\nTags are controlled by `:tags` attribute. In contrast to other attributes, this\none will also inherit all tags defined as a module documentation attributes.","ref":"OpenApiSpex.Controller.html#module-supported-openapi-fields","title":"Supported OpenAPI fields - OpenApiSpex.Controller","type":"module"},{"doc":"```\ndefmodule UserController do\n  @moduledoc tags: [\"Users\"]\n\n  use MyAppWeb, :controller\n  use OpenApiSpex.Controller\n\n  @doc \"\"\"\n  Endpoint summary\n\n  Endpoint description...\n  \"\"\"\n  @doc parameters: [\n         id: [in: :path, type: :string, required: true]\n       ],\n       request_body: {\"Request body to update User\", \"application/json\", UserUpdateBody, required: true},\n       responses: [\n         ok: {\"User document\", \"application/json\", UserSchema},\n         {302, \"Redirect\", \"text/html\", EmptyResponse, headers: %{\"Location\" => %Header{description: \"Redirect Location\"}}}\n       ]\n  def update(conn, %{id: id}) do\n    user_params = conn.body_params\n    # …\n  end\nend\n```","ref":"OpenApiSpex.Controller.html#module-example","title":"Example - OpenApiSpex.Controller","type":"module"},{"doc":"Macros for defining operation specs, shared operation tags, and shared security specs\nin a Phoenix controller.","ref":"OpenApiSpex.ControllerSpecs.html","title":"OpenApiSpex.ControllerSpecs","type":"module"},{"doc":"Here is an example Phoenix controller that uses the ControllerSpecs Operation specs:\n\n    defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n      use OpenApiSpex.ControllerSpecs\n\n      alias MyAppWeb.Schemas.{UserParams, UserResponse}\n\n      tags [\"users\"]\n      security [%{}, %{\"petstore_auth\" => [\"write:users\", \"read:users\"]}]\n\n      operation :update,\n        summary: \"Update user\",\n        parameters: [\n          id: [\n            in: :path,\n            description: \"User ID\",\n            type: :integer,\n            example: 1001\n          ]\n        ],\n        request_body: {\"User params\", \"application/json\", UserParams},\n        responses: [\n          ok: {\"User response\", \"application/json\", UserResponse}\n        ]\n\n      def update(conn, %{\"id\" => id}) do\n        json(conn, %{\n          data: %{\n            id: id,\n            name: \"joe user\",\n            email: \"joe@gmail.com\"\n          }\n        })\n      end\n    end\n\nIf you use Elixir Formatter, `:open_api_spex` can be added to the `:import_deps`\nlist in the `.formatter.exs` file of your project to make parentheses of the\nmacros optional.\n\n`.formatter.exs`:\n\n```elixir\n[\n  import_deps: [:open_api_spex]\n]\n```\n\n## `parameters`\n\n`parameters` is a keyword list (or map) of request parameters (not body parameters). They each represent the\nOpenAPI [Parameter Object](https://spec.openapis.org/oas/v3.1.0#parameter-object).\n\nThere is a convenient shortcut `:type` for base data types supported by open api\n\n```elixir\nparameters: [\n  id: [in: :query, type: :integer, required: true, description: \"User ID\", example: 1001]\n]\n```\n\nThis is equivalent to:\n\n```elixir\nparameters: [\n  id: [in: :query, schema: %OpenApiSpex.Schema{type: :integer}, required: true, description: \"User ID\", example: 1001]\n]\n```\n\nThe keyword value is the parameter name. Each value in the keyword list correlates to a field in the OpenAPI ParameterObject.\n\n## `request_body`\n\nThe `request_body` defines the OpenAPI [RequestBodyObject](https://spec.openapis.org/oas/v3.1.0#request-body-object).\n\nThe `request_body` takes a tuple that is 2-4 elements in length. The elements of the tuple are:\n\n1. The RequestBody `description` field.\n2. The RequestBody `content` field, consisting of a mapping of content types to their `MediaType` objects,\n   or a simple content type string (e.g., \"application/json\").\n   ```elixir\n   content: \"application/json\"\n   ```\n   Or:\n   ```elixir\n   content: %{\"application/text\" => [example: \"some text!\"]}\n   ```\n   Or:\n   ```elixir\n   content: %{\"application/text\" => [%OpenApiSpex.MediaType{example: \"some text!\"}]}\n   ```\n3. The default schema of the RequestBody.\n4. A keyword list of options.\n\n## `responses`\n\nThe `responses` key defines the OpenAPI [Responses Object](https://spec.openapis.org/oas/v3.1.0#fixed-fields-7)\n\nThe `responses` value is a keyword list or map that maps the HTTP status to a\n[ResponseObject](https://spec.openapis.org/oas/v3.1.0#response-object).\n\nIf the the responses is defined using keyword list syntax,\nthe HTTP status codes can be replaced with their text equivalents:\n\n```elixir\nresponses: [\n  ok: {\"User response\", \"application/json\", MyAppWeb.Schemas.UserResponse},\n  unprocessable_entity: {\"Bad request parameters\", \"application/json\", MyAppWeb.Schemas.BadRequestParameters},\n  not_found: {\"Not found\", \"application/json\", MyAppWeb.Schemas.NotFound}\n]\n```\n\nThe full set of atom keys are defined in `Plug.Conn.Status.code/1`.\n\nAlternately, the HTTP status codes can be specified directly:\n\n```elixir\nresponses: %{\n  200 => {\"User response\", \"application/json\", MyAppWeb.Schemas.UserResponse},\n  422 => {\"Bad request parameters\", \"application/json\", MyAppWeb.Schemas.BadRequestParameters},\n  404 => {\"Not found\", \"application/json\", MyAppWeb.Schemas.NotFound}\n}\n```\n\nThe ResponseObject is represented as a tuple that is 2-4 elements in length. The elements of the tuple are:\n\n1. The ResponseObject `description` field.\n2. The ResponseObject `content` field, consisting of a mapping of content types to their `MediaType` objects,\n   or a simple content type string (e.g., \"application/json\").\n   ```elixir\n   content: %{\"application/json\" => [example: \"{[]}\"]}\n   ```\n   Or:\n   ```elixir\n   content: \"application/json\"\n   ```\n3. The default schema of the response body.\n4. A keyword list of options to add to the `OpenApiSpex.Response` or `OpenApiSpex.MediaType` structs\n   that are generated.","ref":"OpenApiSpex.ControllerSpecs.html#module-example","title":"Example - OpenApiSpex.ControllerSpecs","type":"module"},{"doc":"Defines an Operation spec for a controller action.","ref":"OpenApiSpex.ControllerSpecs.html#operation/2","title":"OpenApiSpex.ControllerSpecs.operation/2","type":"macro"},{"doc":"operation :update,\n      summary: \"Update user\",\n      description: \"Updates a user record from the given ID path parameter and request body parameters.\",\n      parameters: [\n        id: [\n          in: :path,\n          description: \"User ID\",\n          type: :integer,\n          example: 1001\n        ]\n      ],\n      request_body: {\"User params\", \"application/json\", UserParams},\n      responses: [\n        ok: {\"User response\", \"application/json\", UserResponse}\n      ],\n      security: [%{}, %{\"petstore_auth\" => [\"write:pets\", \"read:pets\"]}],\n      tags: [\"users\"]","ref":"OpenApiSpex.ControllerSpecs.html#operation/2-example","title":"Example - OpenApiSpex.ControllerSpecs.operation/2","type":"macro"},{"doc":"These options correlate to the\n[Operation fields specified in the Open API spec](https://swagger.io/specification/#operation-object).\nOne difference however, is that the fields defined in Open API use `camelCase` naming,\nwhile the fields used in `ControllerSpecs` use `snake_case` to match Elixir's convention.\n\n- `summary` The operation summary\n- `parameters` The endpoint's parameters. The syntax for `parameters` can take multiple forms:\n  - The common form is a keyword list, where each key is the parameter name, and the value\n    is a keyword list of options that correlate to the fields in an\n    [Open API Parameter Object](https://swagger.io/specification/#parameter-object).\n    For example:\n\n    ```elixir\n      parameters: [\n        id: [\n          in: :path,\n          description: \"User ID\",\n          type: :integer,\n          example: 1001\n        ]\n      ]\n    ```\n  - A `parameters` list can also contain references to parameter schemas. There are two\n    ways to do that:\n\n    ```elixir\n    parameters: [\n      \"$ref\": \"#/components/parameters/user_id\"\n      # or\n      %OpenApiSpex.Reference{\"$ref\": \"#/components/parameters/user_id\"}\n    ]\n    ```\n- `request_body` The endpoint's request body. There are multiple ways to specify a request body:\n  - A three or four-element tuple:\n\n      ```elixir\n      request_body: {\n        \"User update request body\",\n        \"application/json\",\n        UserUpdateRequest,\n        required: true\n      }\n      ```\n\n    The tuple consists of the following:\n    1. The description\n    2. The content-type\n    3. An Open API schema. This can be a schema module that implements the\n       `OpenApiSpex.Schema` [behaviour](https://hexdocs.pm/elixir/Module.html#module-behaviour),\n       or an `OpenApiSpex.Schema` struct.\n    4. A optional keyword list of options. There is only one option available,\n       and that is `required: boolean`.\n- `responses` The endpoint's responses, for each HTTP status code the endpoint may respond with.\n  Multiple syntaxes are supported:\n  - A common syntax is a keyword list, where each key is the textual name of an HTTP status code.\n    For example:\n\n      ```elixir\n      [\n        ok: {\"User response\", \"application/json\", User},\n        not_found: {\"User not found\", \"application/json\", NotFound}\n      ]\n      ```\n\n    The list of names and their code mappings is defined in\n    `Plug.Conn.Status.code/1`.\n\n  - If a map is used, the keys can either be the same atom keys used\n    in the keyword syntax (`%{ok: ...}`), or they can be integers representing\n    the HTTP status code directly:\n\n      ```elixir\n      responses: %{\n        200 => {\"User response\", \"application/json\", User},\n        404 => {\"User not found\", \"application/json\", NotFound}\n      }\n      ```\n\n  - Each response can be a three-element tuple:\n\n      ```elixir\n      responses: [\n        ok: {\"User response\", \"application/json\", User}\n        # Or\n        ok: {\"User response\", \"application/json\", %OpenApiSpex.Schema{...}}\n      ]\n      ```\n\n    This tuple consists of:\n    1. A Description string\n    2. A content-type string\n    3. An Open API schema. This can be a schema module that implements the\n       `OpenApiSpex.Schema` [behaviour](https://hexdocs.pm/elixir/Module.html#module-behaviour),\n       or an `OpenApiSpex.Schema` struct.\n    4. An optional `Keyword` list with the following optional key/values:\n      a. example: an example string\n      b. examples: a list of example strings\n      c. headers: a `Map` with string keys defining the header name and\n         an `OpenApiSpex.Header` struct as a value.\n\n  - If the response represents an empty response, the definition value can\n    be a single string representing the response description. For example:\n\n      ```elixir\n      responses: [\n        no_content: \"Empty response\"\n      ]\n      ```\n\n  - A response can also be defined as an `OpenApiSpex.RequestBody` struct. In fact, all\n    response body syntaxes resolve to this struct.\n\n- Additional fields: There are other Operation fields that can be specified that are not\n  described here. See `OpenApiSpex.Operation` for all the fields.","ref":"OpenApiSpex.ControllerSpecs.html#operation/2-options","title":"Options - OpenApiSpex.ControllerSpecs.operation/2","type":"macro"},{"doc":"Define an Operation for a controller action.\n\nSee `OpenApiSpex.ControllerSpecs` for usage and examples.","ref":"OpenApiSpex.ControllerSpecs.html#operation_spec/3","title":"OpenApiSpex.ControllerSpecs.operation_spec/3","type":"function"},{"doc":"Defines security requirements shared by all operations defined in a controller.\n\nSee [Security Requirement Object spec](https://swagger.io/specification/#securityRequirementObject)\nand `OpenApiSpex.SecurityRequirement` for more information.","ref":"OpenApiSpex.ControllerSpecs.html#security/1","title":"OpenApiSpex.ControllerSpecs.security/1","type":"macro"},{"doc":"Defines a list of tags that all operations in a controller will share.","ref":"OpenApiSpex.ControllerSpecs.html#tags/1","title":"OpenApiSpex.ControllerSpecs.tags/1","type":"macro"},{"doc":"tags [\"users\"]\n\nAll operations defined in the controller will inherit the tags specified\nby this call. If an operation defines its own tags, the tags in this call\nwill be appended to the operation's tags.","ref":"OpenApiSpex.ControllerSpecs.html#tags/1-example","title":"Example - OpenApiSpex.ControllerSpecs.tags/1","type":"macro"},{"doc":"This module is deprecated.\n\nPlease use `OpenApiSpex.Cast` instead.","ref":"OpenApiSpex.DeprecatedCast.html","title":"OpenApiSpex.DeprecatedCast","type":"module"},{"doc":"","ref":"OpenApiSpex.DeprecatedCast.html#cast/3","title":"OpenApiSpex.DeprecatedCast.cast/3","type":"function"},{"doc":"","ref":"OpenApiSpex.DeprecatedCast.html#validate/3","title":"OpenApiSpex.DeprecatedCast.validate/3","type":"function"},{"doc":"","ref":"OpenApiSpex.DeprecatedCast.html#validate/4","title":"OpenApiSpex.DeprecatedCast.validate/4","type":"function"},{"doc":"Defines the `OpenApiSpex.Discriminator.t` type.","ref":"OpenApiSpex.Discriminator.html","title":"OpenApiSpex.Discriminator","type":"module"},{"doc":"Resolve the schema that should be used to cast/validate a value using a `Discriminator`.","ref":"OpenApiSpex.Discriminator.html#resolve/3","title":"OpenApiSpex.Discriminator.resolve/3","type":"function"},{"doc":"[Discriminator Object](https://swagger.io/specification/#discriminatorObject)\n\nWhen request bodies or response payloads may be one of a number of different schemas,\na discriminator object can be used to aid in serialization, deserialization, and validation.\nThe discriminator is a specific object in a schema which is used to inform the consumer of the\nspecification of an alternative schema based on the value associated with it.","ref":"OpenApiSpex.Discriminator.html#t:t/0","title":"OpenApiSpex.Discriminator.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Encoding.t` type.","ref":"OpenApiSpex.Encoding.html","title":"OpenApiSpex.Encoding","type":"module"},{"doc":"[Encoding Object](https://swagger.io/specification/#encodingObject)\n\nA single encoding definition applied to a single schema property.","ref":"OpenApiSpex.Encoding.html#t:t/0","title":"OpenApiSpex.Encoding.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Example.t` type.","ref":"OpenApiSpex.Example.html","title":"OpenApiSpex.Example","type":"module"},{"doc":"[Example Object](https://swagger.io/specification/#exampleObject)\n\nIn all cases, the example value is expected to be compatible with the type schema of its associated value.","ref":"OpenApiSpex.Example.html#t:t/0","title":"OpenApiSpex.Example.t/0","type":"type"},{"doc":"Export spec in specified encoding","ref":"OpenApiSpex.ExportSpec.html","title":"OpenApiSpex.ExportSpec","type":"module"},{"doc":"","ref":"OpenApiSpex.ExportSpec.html#call/3","title":"OpenApiSpex.ExportSpec.call/3","type":"function"},{"doc":"","ref":"OpenApiSpex.Extendable.html","title":"OpenApiSpex.Extendable","type":"protocol"},{"doc":"","ref":"OpenApiSpex.Extendable.html#to_map/1","title":"OpenApiSpex.Extendable.to_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Extendable.html#t:t/0","title":"OpenApiSpex.Extendable.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.ExternalDocumentation.t` type.","ref":"OpenApiSpex.ExternalDocumentation.html","title":"OpenApiSpex.ExternalDocumentation","type":"module"},{"doc":"[External Documentation Object](https://swagger.io/specification/#externalDocumentationObject)\n\nAllows referencing an external resource for extended documentation.","ref":"OpenApiSpex.ExternalDocumentation.html#t:t/0","title":"OpenApiSpex.ExternalDocumentation.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Header.t` type.","ref":"OpenApiSpex.Header.html","title":"OpenApiSpex.Header","type":"module"},{"doc":"[Header Object](https://swagger.io/specification/#headerObject)\n\nThe Header Object follows the structure of the Parameter Object with the following changes:\n\n - name MUST NOT be specified, it is given in the corresponding headers map.\n - in MUST NOT be specified, it is implicitly in header.\n - All traits that are affected by the location MUST be applicable to a location of header (for example, style).","ref":"OpenApiSpex.Header.html#t:t/0","title":"OpenApiSpex.Header.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Info.t` type.","ref":"OpenApiSpex.Info.html","title":"OpenApiSpex.Info","type":"module"},{"doc":"[Info Object](https://swagger.io/specification/#infoObject)\n\nThe object provides metadata about the API. The metadata MAY be used by the clients if needed,\nand MAY be presented in editing or documentation generation tools for convenience.","ref":"OpenApiSpex.Info.html#t:t/0","title":"OpenApiSpex.Info.t/0","type":"type"},{"doc":"Schema for the default error renderer used by `OpenApiSpex.Plug.CastAndValidate`.","ref":"OpenApiSpex.JsonErrorResponse.html","title":"OpenApiSpex.JsonErrorResponse","type":"module"},{"doc":"@doc responses: %{\n           201 => {\"User\", \"application/json\", UserResponse}\n           422 => {\"Unprocessable Entity\", \"application/json\", OpenApiSpex.JsonErrorResponse}\n         }","ref":"OpenApiSpex.JsonErrorResponse.html#module-examples","title":"Examples - OpenApiSpex.JsonErrorResponse","type":"module"},{"doc":"Convenience function to return that wraps JsonErrorResponse in an Operation response.","ref":"OpenApiSpex.JsonErrorResponse.html#response/0","title":"OpenApiSpex.JsonErrorResponse.response/0","type":"function"},{"doc":"@doc responses: %{\n           201 => {\"User\", \"application/json\", UserResponse}\n           422 => OpenApiSpex.JsonErrorResponse.response()\n         }","ref":"OpenApiSpex.JsonErrorResponse.html#response/0-examples","title":"Examples - OpenApiSpex.JsonErrorResponse.response/0","type":"function"},{"doc":"","ref":"OpenApiSpex.JsonErrorResponse.html#schema/0","title":"OpenApiSpex.JsonErrorResponse.schema/0","type":"function"},{"doc":"","ref":"OpenApiSpex.JsonErrorResponse.html#t:t/0","title":"OpenApiSpex.JsonErrorResponse.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.License.t` type.","ref":"OpenApiSpex.License.html","title":"OpenApiSpex.License","type":"module"},{"doc":"[License Object](https://swagger.io/specification/#licenseObject)\n\nLicense information for the exposed API.","ref":"OpenApiSpex.License.html#t:t/0","title":"OpenApiSpex.License.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Link.t` type.","ref":"OpenApiSpex.Link.html","title":"OpenApiSpex.Link","type":"module"},{"doc":"[Link Object](https://swagger.io/specification/#linkObject)\n\nThe Link object represents a possible design-time link for a response.\n\nThe presence of a link does not guarantee the caller's ability to successfully invoke it,\nrather it provides a known relationship and traversal mechanism between responses and other operations.\n\nUnlike dynamic links (i.e. links provided in the response payload),\nthe OAS linking mechanism does not require link information in the runtime response.\n\nFor computing links, and providing instructions to execute them,\na runtime expression is used for accessing values in an operation and\nusing them as parameters while invoking the linked operation.","ref":"OpenApiSpex.Link.html#t:t/0","title":"OpenApiSpex.Link.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.MediaType.t` type.","ref":"OpenApiSpex.MediaType.html","title":"OpenApiSpex.MediaType","type":"module"},{"doc":"[Media Type Object](https://swagger.io/specification/#mediaTypeObject)\n\nEach Media Type Object provides schema and examples for the media type identified by its key.","ref":"OpenApiSpex.MediaType.html#t:t/0","title":"OpenApiSpex.MediaType.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.OAuthFlow.t` type.","ref":"OpenApiSpex.OAuthFlow.html","title":"OpenApiSpex.OAuthFlow","type":"module"},{"doc":"[OAuth Flow Object](https://swagger.io/specification/#oauthFlowObject)\n\nConfiguration details for a supported OAuth Flow","ref":"OpenApiSpex.OAuthFlow.html#t:t/0","title":"OpenApiSpex.OAuthFlow.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.OAuthFlows.t` type.","ref":"OpenApiSpex.OAuthFlows.html","title":"OpenApiSpex.OAuthFlows","type":"module"},{"doc":"[OAuth Flows Object](https://swagger.io/specification/#oauthFlowsObject)\n\nAllows configuration of the supported OAuth Flows.","ref":"OpenApiSpex.OAuthFlows.html#t:t/0","title":"OpenApiSpex.OAuthFlows.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.OpenApi.t` type and the behaviour for application modules that\nconstruct an `OpenApiSpex.OpenApi.t` at runtime.","ref":"OpenApiSpex.OpenApi.html","title":"OpenApiSpex.OpenApi","type":"behaviour"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#from_map/1","title":"OpenApiSpex.OpenApi.from_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#json_encoder/0","title":"OpenApiSpex.OpenApi.json_encoder/0","type":"function"},{"doc":"A spec/0 callback function is required for use with the `OpenApiSpex.Plug.PutApiSpec` plug.","ref":"OpenApiSpex.OpenApi.html#c:spec/0","title":"OpenApiSpex.OpenApi.spec/0","type":"callback"},{"doc":"@impl OpenApiSpex.OpenApi\n    def spec do\n      %OpenApi{\n        servers: [\n          # Populate the Server info from a phoenix endpoint\n          Server.from_endpoint(MyAppWeb.Endpoint)\n        ],\n        info: %Info{\n          title: \"My App\",\n          version: \"1.0\"\n        },\n        # populate the paths from a phoenix router\n        paths: Paths.from_router(MyAppWeb.Router)\n      }\n      |> OpenApiSpex.resolve_schema_modules() # discover request/response schemas from path specs\n    end","ref":"OpenApiSpex.OpenApi.html#c:spec/0-example","title":"Example - OpenApiSpex.OpenApi.spec/0","type":"callback"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#to_map/1","title":"OpenApiSpex.OpenApi.to_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#to_map/2","title":"OpenApiSpex.OpenApi.to_map/2","type":"function"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#yaml_encoder/0","title":"OpenApiSpex.OpenApi.yaml_encoder/0","type":"function"},{"doc":"[OpenAPI Object](https://swagger.io/specification/#oasObject)\n\nThis is the root document object of the OpenAPI document.","ref":"OpenApiSpex.OpenApi.html#t:t/0","title":"OpenApiSpex.OpenApi.t/0","type":"type"},{"doc":"This module exposes functionality to convert an arbitrary map into a OpenApi struct.","ref":"OpenApiSpex.OpenApi.Decode.html","title":"OpenApiSpex.OpenApi.Decode","type":"module"},{"doc":"","ref":"OpenApiSpex.OpenApi.Decode.html#decode/1","title":"OpenApiSpex.OpenApi.Decode.decode/1","type":"function"},{"doc":"Defines the `OpenApiSpex.Operation.t` type.","ref":"OpenApiSpex.Operation.html","title":"OpenApiSpex.Operation","type":"module"},{"doc":"Cast params to the types defined by the schemas of the operation parameters and requestBody","ref":"OpenApiSpex.Operation.html#cast/4","title":"OpenApiSpex.Operation.cast/4","type":"function"},{"doc":"Constructs an Operation struct from plug module and opts","ref":"OpenApiSpex.Operation.html#from_plug/2","title":"OpenApiSpex.Operation.from_plug/2","type":"function"},{"doc":"Constructs an Operation struct from the plug and opts specified in the given route","ref":"OpenApiSpex.Operation.html#from_route/1","title":"OpenApiSpex.Operation.from_route/1","type":"function"},{"doc":"Shorthand for constructing an `OpenApiSpex.Parameter` given name, location, type, description and optional examples","ref":"OpenApiSpex.Operation.html#parameter/5","title":"OpenApiSpex.Operation.parameter/5","type":"function"},{"doc":"iex> Operation.parameter(\n    ...>   :status,\n    ...>   :query,\n    ...>   %OpenApiSpex.Schema{type: :string, enum: [\"pending\", \"in_progress\", \"completed\"]},\n    ...>   \"The status of an entity\"\n    ...> )\n    %OpenApiSpex.Parameter{\n      name: :status,\n      in: :query,\n      description: \"The status of an entity\",\n      required: false,\n      schema: %OpenApiSpex.Schema{enum: [\"pending\", \"in_progress\", \"completed\"], type: :string}\n    }","ref":"OpenApiSpex.Operation.html#parameter/5-examples","title":"Examples - OpenApiSpex.Operation.parameter/5","type":"function"},{"doc":"Shorthand for constructing a RequestBody with description, media_type, schema and optional examples","ref":"OpenApiSpex.Operation.html#request_body/4","title":"OpenApiSpex.Operation.request_body/4","type":"function"},{"doc":"Shorthand for constructing a Response with description, media_type, schema and optional headers or examples","ref":"OpenApiSpex.Operation.html#response/4","title":"OpenApiSpex.Operation.response/4","type":"function"},{"doc":"Validate params against the schemas of the operation parameters and requestBody","ref":"OpenApiSpex.Operation.html#validate/4","title":"OpenApiSpex.Operation.validate/4","type":"function"},{"doc":"[Operation Object](https://swagger.io/specification/#operationObject)\n\nDescribes a single API operation on a path.","ref":"OpenApiSpex.Operation.html#t:t/0","title":"OpenApiSpex.Operation.t/0","type":"type"},{"doc":"Casts and validates a request from a Plug conn.","ref":"OpenApiSpex.Operation2.html","title":"OpenApiSpex.Operation2","type":"module"},{"doc":"","ref":"OpenApiSpex.Operation2.html#cast/5","title":"OpenApiSpex.Operation2.cast/5","type":"function"},{"doc":"Defines the `OpenApiSpex.Parameter.t` type.","ref":"OpenApiSpex.Parameter.html","title":"OpenApiSpex.Parameter","type":"module"},{"doc":"Gets the media type for a parameter, if not present `nil` is returned.","ref":"OpenApiSpex.Parameter.html#media_type/1","title":"OpenApiSpex.Parameter.media_type/1","type":"function"},{"doc":"Sets the schema for a parameter from a simple type, reference or Schema","ref":"OpenApiSpex.Parameter.html#put_schema/2","title":"OpenApiSpex.Parameter.put_schema/2","type":"function"},{"doc":"Gets the schema for a parameter, from the `schema` key or `content` key, which ever is populated.","ref":"OpenApiSpex.Parameter.html#schema/1","title":"OpenApiSpex.Parameter.schema/1","type":"function"},{"doc":"Valid values for the `in` key in the `OpenApiSpex.Parameter` struct.","ref":"OpenApiSpex.Parameter.html#t:location/0","title":"OpenApiSpex.Parameter.location/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Parameter.html#t:parameters/0","title":"OpenApiSpex.Parameter.parameters/0","type":"type"},{"doc":"Valid values for the `style` key in the `OpenApiSpex.Parameter` struct.","ref":"OpenApiSpex.Parameter.html#t:style/0","title":"OpenApiSpex.Parameter.style/0","type":"type"},{"doc":"[Parameter Object](https://swagger.io/specification/#parameterObject)\n\nDescribes a single operation parameter.\n\nA unique parameter is defined by a combination of a name and location.","ref":"OpenApiSpex.Parameter.html#t:t/0","title":"OpenApiSpex.Parameter.t/0","type":"type"},{"doc":"There are four possible parameter locations specified by the in field:\n\n  - path: Used together with Path Templating, where the parameter value is actually part of the operation's URL. This does not include the host or base path of the API. For example, in `/items/{itemId}`, the path parameter is itemId.\n  - query: Parameters that are appended to the URL. For example, in `/items?id=###`, the query parameter is id.\n  - header: Custom headers that are expected as part of the request. Note that RFC7230 states header names are case insensitive.\n  - cookie: Used to pass a specific cookie value to the API.","ref":"OpenApiSpex.Parameter.html#t:t/0-parameter-locations","title":"Parameter Locations - OpenApiSpex.Parameter.t/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Parameter.html#t:type/0","title":"OpenApiSpex.Parameter.type/0","type":"type"},{"doc":"Defines the `OpenApiSpex.PathItem.t` type.","ref":"OpenApiSpex.PathItem.html","title":"OpenApiSpex.PathItem","type":"module"},{"doc":"Builds a PathItem struct from a list of routes that share a path.","ref":"OpenApiSpex.PathItem.html#from_routes/1","title":"OpenApiSpex.PathItem.from_routes/1","type":"function"},{"doc":"Represents a route from in a Plug/Phoenix application.\nEg from the generated `__routes__` function in a Phoenix.Router module.","ref":"OpenApiSpex.PathItem.html#t:route/0","title":"OpenApiSpex.PathItem.route/0","type":"type"},{"doc":"[Path Item Object](https://swagger.io/specification/#pathItemObject)\n\nDescribes the operations available on a single path.\nA Path Item MAY be empty, due to ACL constraints.\nThe path itself is still exposed to the documentation viewer\nbut they will not know which operations and parameters are available.","ref":"OpenApiSpex.PathItem.html#t:t/0","title":"OpenApiSpex.PathItem.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Paths.t` type.","ref":"OpenApiSpex.Paths.html","title":"OpenApiSpex.Paths","type":"module"},{"doc":"Create a Paths map from the routes in the given router module.","ref":"OpenApiSpex.Paths.html#from_router/1","title":"OpenApiSpex.Paths.from_router/1","type":"function"},{"doc":"Create a Paths map from a list of routes.","ref":"OpenApiSpex.Paths.html#from_routes/1","title":"OpenApiSpex.Paths.from_routes/1","type":"function"},{"doc":"Paths.from_routes([\n      %{path: \"/v1/contacts\", verb: :post, plug: MyAppWeb.V1.ContactController, plug_opts: :create}\n    ])","ref":"OpenApiSpex.Paths.html#from_routes/1-example","title":"Example - OpenApiSpex.Paths.from_routes/1","type":"function"},{"doc":"[Paths Object](https://swagger.io/specification/#pathsObject)\n\nHolds the relative paths to the individual endpoints and their operations.\nThe path is appended to the URL from the Server Object in order to construct the full URL.\nThe Paths MAY be empty, due to ACL constraints.","ref":"OpenApiSpex.Paths.html#t:path/0","title":"OpenApiSpex.Paths.path/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Paths.html#t:t/0","title":"OpenApiSpex.Paths.t/0","type":"type"},{"doc":"A cache implementation leveraging Application env.","ref":"OpenApiSpex.Plug.AppEnvCache.html","title":"OpenApiSpex.Plug.AppEnvCache","type":"module"},{"doc":"Cache for OpenApiSpex API specs.\n\nSettings:\n\n```elixir\nconfig :open_api_spex, :cache_adapter, Module\n```\n\nThere are three cache implementations:\n\n* `OpenApiSpex.Plug.PersistentTermCache` - default\n* `OpenApiSpex.Plug.AppEnvCache` - for VMs that don't support `persistent_term`\n* `OpenApiSpex.Plug.NoneCache` - none cache\n\nIf you are constantly modifying specs during development, you can configure the cache adapter\nin `dev.exs` as follows to disable caching:\n\n```elixir\nconfig :open_api_spex, :cache_adapter, OpenApiSpex.Plug.NoneCache\n```","ref":"OpenApiSpex.Plug.Cache.html","title":"OpenApiSpex.Plug.Cache","type":"behaviour"},{"doc":"Get cache adapter","ref":"OpenApiSpex.Plug.Cache.html#adapter/0","title":"OpenApiSpex.Plug.Cache.adapter/0","type":"function"},{"doc":"","ref":"OpenApiSpex.Plug.Cache.html#c:erase/1","title":"OpenApiSpex.Plug.Cache.erase/1","type":"callback"},{"doc":"","ref":"OpenApiSpex.Plug.Cache.html#c:get/1","title":"OpenApiSpex.Plug.Cache.get/1","type":"callback"},{"doc":"","ref":"OpenApiSpex.Plug.Cache.html#c:put/2","title":"OpenApiSpex.Plug.Cache.put/2","type":"callback"},{"doc":"Only erase cache, put again when plug starting","ref":"OpenApiSpex.Plug.Cache.html#refresh/0","title":"OpenApiSpex.Plug.Cache.refresh/0","type":"function"},{"doc":"Module plug that will cast the `Conn.params` and `Conn.body_params` according to the schemas defined for the operation.\nNote that when using this plug, the body params are no longer merged into `Conn.params` and must be read from `Conn.body_params`\nseparately.\n\nThe operation_id can be given at compile time as an argument to `init`:\n\n    plug OpenApiSpex.Plug.Cast, operation_id: \"MyApp.ShowUser\"\n\nFor phoenix applications, the operation_id can be obtained at runtime automatically.\n\n    defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n      plug OpenApiSpex.Plug.Cast\n      ...\n    end\n\nIf you want customize the error response, you can provide the `:render_error` option to register a plug which creates\na custom response in the case of a validation error.","ref":"OpenApiSpex.Plug.Cast.html","title":"OpenApiSpex.Plug.Cast","type":"module"},{"doc":"defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n      plug OpenApiSpex.Plug.Cast,\n      render_error: MyApp.RenderError\n\n      ...\n    end\n\n    defmodule MyApp.RenderError do\n      def init(opts), do: opts\n\n      def call(conn, reason) do\n        msg = %{error: reason} |> Poison.encode!()\n\n        conn\n        |> Conn.put_resp_content_type(\"application/json\")\n        |> Conn.send_resp(400, msg)\n      end\n    end","ref":"OpenApiSpex.Plug.Cast.html#module-example","title":"Example - OpenApiSpex.Plug.Cast","type":"module"},{"doc":"Module plug that will cast and validate the `Conn.params` and `Conn.body_params` according to the schemas defined for the operation.\nNote that when using this plug, the body params are no longer merged into `Conn.params` and must be read from `Conn.body_params`\nseparately.\n\nThe operation_id can be given at compile time as an argument to `init`:\n\n    plug OpenApiSpex.Plug.CastAndValidate,\n      json_render_error_v2: true,\n      operation_id: \"MyApp.ShowUser\"\n\nFor phoenix applications, the operation_id can be obtained at runtime automatically.\n\n    defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n      plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true\n      ...\n    end\n\nCasted params and body params are always stored in `conn.private`.\nThe option `:replace_params` can be set to false to avoid overwriting conn `:body_params` and `:params`\nwith their casted version.\n\n    plug OpenApiSpex.Plug.CastAndValidate,\n      json_render_error_v2: true,\n      operation_id: \"MyApp.ShowUser\",\n      replace_params: false\n\nIf you want customize the error response, you can provide the `:render_error` option to register a plug which creates\na custom response in the case of a validation error.","ref":"OpenApiSpex.Plug.CastAndValidate.html","title":"OpenApiSpex.Plug.CastAndValidate","type":"module"},{"doc":"defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n      plug OpenApiSpex.Plug.CastAndValidate, render_error: MyApp.RenderError\n      ...\n    end\n\n    defmodule MyApp.RenderError do\n      def init(opts), do: opts\n\n      def call(conn, reason) do\n        msg = Jason.encode!(%{error: reason})\n\n        conn\n        |> Conn.put_resp_content_type(\"application/json\")\n        |> Conn.send_resp(400, msg)\n      end\n    end","ref":"OpenApiSpex.Plug.CastAndValidate.html#module-example","title":"Example - OpenApiSpex.Plug.CastAndValidate","type":"module"},{"doc":"Renders errors using a quasi-json:api-compliant data shape.\n\nWARNING: Do not use this module directly. It will be renamed in version 4.0\nTo use this module in a backwards-compatible way, call CastAndValidate like this:\n\n    plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true","ref":"OpenApiSpex.Plug.JsonRenderErrorV2.html","title":"OpenApiSpex.Plug.JsonRenderErrorV2","type":"module"},{"doc":"A cache adapter to disable caching. Intended to be used in development.\n\nConfigure it with:\n\n```elixir\n# config/dev.exs\nconfig :open_api_spex, :cache_adapter, OpenApiSpex.Plug.NoneCache\n```","ref":"OpenApiSpex.Plug.NoneCache.html","title":"OpenApiSpex.Plug.NoneCache","type":"module"},{"doc":"A cache leveraging `:persistent_term`.","ref":"OpenApiSpex.Plug.PersistentTermCache.html","title":"OpenApiSpex.Plug.PersistentTermCache","type":"module"},{"doc":"Module plug that calls a given module to obtain the Api Spec and store it as private in the Conn.\n\nThis allows downstream plugs to use the API spec for casting, validating and rendering.","ref":"OpenApiSpex.Plug.PutApiSpec.html","title":"OpenApiSpex.Plug.PutApiSpec","type":"module"},{"doc":"- module: A module implementing the `OpenApiSpex.OpenApi` behaviour","ref":"OpenApiSpex.Plug.PutApiSpec.html#module-options","title":"Options - OpenApiSpex.Plug.PutApiSpec","type":"module"},{"doc":"plug OpenApiSpex.Plug.PutApiSpec, module: MyAppWeb.ApiSpec","ref":"OpenApiSpex.Plug.PutApiSpec.html#module-example","title":"Example - OpenApiSpex.Plug.PutApiSpec","type":"module"},{"doc":"","ref":"OpenApiSpex.Plug.PutApiSpec.html#get_and_cache_controller_action/3","title":"OpenApiSpex.Plug.PutApiSpec.get_and_cache_controller_action/3","type":"function"},{"doc":"","ref":"OpenApiSpex.Plug.PutApiSpec.html#get_spec_and_operation_lookup/1","title":"OpenApiSpex.Plug.PutApiSpec.get_spec_and_operation_lookup/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Plug.PutApiSpec.html#spec_module/1","title":"OpenApiSpex.Plug.PutApiSpec.spec_module/1","type":"function"},{"doc":"Renders the API spec as a JSON response.\n\nThe API spec must be stored in the conn by `OpenApiSpex.Plug.PutApiSpec` earlier in the plug pipeline.","ref":"OpenApiSpex.Plug.RenderSpec.html","title":"OpenApiSpex.Plug.RenderSpec","type":"module"},{"doc":"defmodule MyAppWeb.Router do\n      use Phoenix.Router\n      alias MyAppWeb.UserController\n\n      pipeline :api do\n        plug :accepts, [\"json\"]\n        plug OpenApiSpex.Plug.PutApiSpec, module: MyAppWeb.ApiSpec\n      end\n\n      scope \"/api\" do\n        pipe_through :api\n        resources \"/users\", UserController, only: [:create, :index, :show]\n        get \"/openapi\", OpenApiSpex.Plug.RenderSpec, []\n      end\n    end","ref":"OpenApiSpex.Plug.RenderSpec.html#module-example","title":"Example - OpenApiSpex.Plug.RenderSpec","type":"module"},{"doc":"Module plug that serves SwaggerUI.\n\nThe full path to the API spec must be given as a plug option.\nThe API spec should be served at the given path, see `OpenApiSpex.Plug.RenderSpec`","ref":"OpenApiSpex.Plug.SwaggerUI.html","title":"OpenApiSpex.Plug.SwaggerUI","type":"module"},{"doc":"SwaggerUI can be configured through plug `opts`.\nAll options will be converted from `snake_case` to `camelCase` and forwarded to the `SwaggerUIBundle` constructor.\nSee the [swagger-ui configuration docs](https://swagger.io/docs/open-source-tools/swagger-ui/usage/configuration/) for details.\nShould dynamic configuration be required, the `config_url` option can be set to an API endpoint that will provide additional config.","ref":"OpenApiSpex.Plug.SwaggerUI.html#module-configuring-swaggerui","title":"Configuring SwaggerUI - OpenApiSpex.Plug.SwaggerUI","type":"module"},{"doc":"scope \"/\" do\n      pipe_through :browser # Use the default browser stack\n\n      get \"/\", MyAppWeb.PageController, :index\n      get \"/swaggerui\", OpenApiSpex.Plug.SwaggerUI,\n        path: \"/api/openapi\",\n        default_model_expand_depth: 3,\n        display_operation_id: true\n    end\n\n    # Other scopes may use custom stacks.\n    scope \"/api\" do\n      pipe_through :api\n      resources \"/users\", MyAppWeb.UserController, only: [:index, :create, :show]\n      get \"/openapi\", OpenApiSpex.Plug.RenderSpec, :show\n    end","ref":"OpenApiSpex.Plug.SwaggerUI.html#module-example","title":"Example - OpenApiSpex.Plug.SwaggerUI","type":"module"},{"doc":"","ref":"OpenApiSpex.Plug.SwaggerUI.html#get_nonce/3","title":"OpenApiSpex.Plug.SwaggerUI.get_nonce/3","type":"function"},{"doc":"Initializes the plug.","ref":"OpenApiSpex.Plug.SwaggerUI.html#init/1","title":"OpenApiSpex.Plug.SwaggerUI.init/1","type":"function"},{"doc":"* `:path` - Required. The URL path to the API definition.\n * `:oauth` - Optional. Config to pass to the `SwaggerUIBundle.initOAuth()` function.\n * `:csp_nonce_assign_key` - Optional. An assign key to find the CSP nonce value used\n   for assets. Supports either `atom()` or a map of type\n   `%{optional(:script) => atom(), optional(:style) => atom()}`. You will probably\n   want to set this on the `SwaggerUIOAuth2Redirect` plug as well.\n * all other opts - forwarded to the `SwaggerUIBundle` constructor","ref":"OpenApiSpex.Plug.SwaggerUI.html#init/1-options","title":"Options - OpenApiSpex.Plug.SwaggerUI.init/1","type":"function"},{"doc":"get \"/swaggerui\", OpenApiSpex.Plug.SwaggerUI,\n      path: \"/api/openapi\",\n      default_model_expand_depth: 3,\n      display_operation_id: true,\n      csp_nonce_assign_key: %{script: :script_src_nonce, style: :style_src_nonce}","ref":"OpenApiSpex.Plug.SwaggerUI.html#init/1-example","title":"Example - OpenApiSpex.Plug.SwaggerUI.init/1","type":"function"},{"doc":"This plug will handle the callback from an OAuth server","ref":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.html","title":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect","type":"module"},{"doc":"Initializes the plug.","ref":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.html#init/1","title":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.init/1","type":"function"},{"doc":"* `:csp_nonce_assign_key` - Optional. An assign key to find the CSP nonce value used\n   for assets. Supports either `atom()` or a map of type `%{optional(:script) => atom()}`.","ref":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.html#init/1-options","title":"Options - OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.init/1","type":"function"},{"doc":"get \"/oauth2-redirect.html\",\n        OpenApiSpex.Plug.SwaggerUIOAuth2Redirect,\n        csp_nonce_assign_key: %{script: :script_src_nonce}","ref":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.html#init/1-example","title":"Example - OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.init/1","type":"function"},{"doc":"Module plug that validates params against the schema defined for an operation.\n\nIf validation fails, the plug will send a 422 response with the reason as the body.\nThis plug should always be run after `OpenApiSpex.Plug.Cast`, as it expects the params map to\nhave atom keys and query params converted from strings to the appropriate types.","ref":"OpenApiSpex.Plug.Validate.html","title":"OpenApiSpex.Plug.Validate","type":"module"},{"doc":"defmodule MyApp.UserController do\n      use Phoenix.Controller\n      plug OpenApiSpex.Plug.Cast\n      plug OpenApiSpex.Plug.Validate\n      ...\n    end\n\nIf you want customize the error response, you can provide the `:render_error` option to register a plug which creates\na custom response in the case of a validation error.","ref":"OpenApiSpex.Plug.Validate.html#module-example","title":"Example - OpenApiSpex.Plug.Validate","type":"module"},{"doc":"defmodule MyApp.UserController do\n      use Phoenix.Controller\n      plug OpenApiSpex.Plug.Cast\n      plug OpenApiSpex.Plug.Validate,\n      render_error: MyApp.RenderError\n\n      def render_error(conn, reason) do\n        msg = %{error: reason} |> Poison.encode!()\n\n        conn\n        |> Conn.put_resp_content_type(\"application/json\")\n        |> Conn.send_resp(400, msg)\n      end\n      ...\n    end\n\n    defmodule MyApp.RenderError do\n      def init(opts), do: opts\n\n      def call(conn, reason) do\n        msg = %{error: reason} |> Poison.encode!()\n\n        conn\n        |> Conn.put_resp_content_type(\"application/json\")\n        |> Conn.send_resp(400, msg)\n      end\n    end","ref":"OpenApiSpex.Plug.Validate.html#module-example","title":"Example - OpenApiSpex.Plug.Validate","type":"module"},{"doc":"","ref":"OpenApiSpex.Plug.Validate.html#render_error/2","title":"OpenApiSpex.Plug.Validate.render_error/2","type":"function"},{"doc":"Defines the `OpenApiSpex.Reference.t` type.","ref":"OpenApiSpex.Reference.html","title":"OpenApiSpex.Reference","type":"module"},{"doc":"","ref":"OpenApiSpex.Reference.html#resolve_parameter/2","title":"OpenApiSpex.Reference.resolve_parameter/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Reference.html#resolve_request_body/2","title":"OpenApiSpex.Reference.resolve_request_body/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Reference.html#resolve_response/2","title":"OpenApiSpex.Reference.resolve_response/2","type":"function"},{"doc":"Resolve a `Reference` to the `Schema` it refers to.","ref":"OpenApiSpex.Reference.html#resolve_schema/2","title":"OpenApiSpex.Reference.resolve_schema/2","type":"function"},{"doc":"iex> alias OpenApiSpex.{Reference, Schema}\n    ...> schemas = %{\"user\" => %Schema{title: \"user\", type: :object}}\n    ...> Reference.resolve_schema(%Reference{\"$ref\": \"#/components/schemas/user\"}, schemas)\n    %OpenApiSpex.Schema{type: :object, title: \"user\"}","ref":"OpenApiSpex.Reference.html#resolve_schema/2-examples","title":"Examples - OpenApiSpex.Reference.resolve_schema/2","type":"function"},{"doc":"[Reference Object](https://swagger.io/specification/#referenceObject)\n\nA simple object to allow referencing other components in the specification, internally and externally.\nThe Reference Object is defined by JSON Reference and follows the same structure, behavior and rules.","ref":"OpenApiSpex.Reference.html#t:t/0","title":"OpenApiSpex.Reference.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.RequestBody.t` type.","ref":"OpenApiSpex.RequestBody.html","title":"OpenApiSpex.RequestBody","type":"module"},{"doc":"[Request Body Object](https://swagger.io/specification/#requestBodyObject)\n\nDescribes a single request body.","ref":"OpenApiSpex.RequestBody.html#t:t/0","title":"OpenApiSpex.RequestBody.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Response.t` type.","ref":"OpenApiSpex.Response.html","title":"OpenApiSpex.Response","type":"module"},{"doc":"Resolve a `Reference` to the `Response` it refers to.","ref":"OpenApiSpex.Response.html#resolve_response/2","title":"OpenApiSpex.Response.resolve_response/2","type":"function"},{"doc":"iex> alias OpenApiSpex.{Response, Reference}\n    ...> responses = %{\"aresponse\" => %Response{description: \"Some response\"}}\n    ...> Response.resolve_response(%Reference{\"$ref\": \"#/components/responses/aresponse\"}, responses)\n    %OpenApiSpex.Response{description: \"Some response\"}","ref":"OpenApiSpex.Response.html#resolve_response/2-examples","title":"Examples - OpenApiSpex.Response.resolve_response/2","type":"function"},{"doc":"[Response Object](https://swagger.io/specification/#responseObject)\n\nDescribes a single response from an API Operation, including design-time, static links to operations based on the response.","ref":"OpenApiSpex.Response.html#t:t/0","title":"OpenApiSpex.Response.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Responses.t` type.","ref":"OpenApiSpex.Responses.html","title":"OpenApiSpex.Responses","type":"module"},{"doc":"[Responses Object](https://swagger.io/specification/#responsesObject)\n\nA container for the expected responses of an operation. The container maps a HTTP response code to the expected response.\nThe documentation is not necessarily expected to cover all possible HTTP response codes because they may not be known in advance.\nHowever, documentation is expected to cover a successful operation response and any known errors.\nThe default MAY be used as a default response object for all HTTP codes that are not covered individually by the specification.\nThe Responses Object MUST contain at least one response code, and it SHOULD be the response for a successful operation call.","ref":"OpenApiSpex.Responses.html#t:t/0","title":"OpenApiSpex.Responses.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Schema.t` type and operations for casting and validating against a schema.\n\nThe `OpenApiSpex.schema` macro can be used to declare schemas with an associated struct and JSON Encoder.","ref":"OpenApiSpex.Schema.html","title":"OpenApiSpex.Schema","type":"behaviour"},{"doc":"defmodule MyApp.Schemas do\n      defmodule EmailString do\n        @behaviour OpenApiSpex.Schema\n        def schema do\n          %OpenApiSpex.Schema {\n            title: \"EmailString\",\n            type: :string,\n            format: :email\n          }\n        end\n      end\n\n      defmodule Person do\n        require OpenApiSpex\n        alias OpenApiSpex.{Reference, Schema}\n\n        OpenApiSpex.schema(%{\n          type: :object,\n          required: [:name],\n          properties: %{\n            name: %Schema{type: :string},\n            address: %Reference{\"$ref\": \"#/components/schemas/Address\"},\n            age: %Schema{type: :integer, format: :int32, minimum: 0}\n          }\n        })\n      end\n\n      defmodule StringDictionary do\n        @behaviour OpenApiSpex.Schema\n\n        def schema() do\n          %OpenApiSpex.Schema{\n            type: :object,\n            additionalProperties: %OpenApiSpex.Schema{\n              type: :string\n            }\n          }\n        end\n      end\n\n      defmodule PetCommon do\n        require OpenApiSpex\n        alias OpenApiSpex.{Schema, Discriminator}\n        OpenApiSpex.schema(%{\n          title: \"PetCommon\",\n          description: \"Properties common to all Pets\",\n          type: :object,\n          properties: %{\n            name: %Schema{type: :string},\n            petType: %Schema{type: :string}\n          },\n          required: [:name, :petType]\n        })\n      end\n\n      defmodule Cat do\n        require OpenApiSpex\n        alias OpenApiSpex.Schema\n        OpenApiSpex.schema(%{\n          title: \"Cat\",\n          type: :object,\n          description: \"A representation of a cat. Note that `Cat` will be used as the discriminator value.\",\n          allOf: [\n            PetCommon,\n            %Schema{\n              type: :object,\n              properties: %{\n                huntingSkill: %Schema{\n                  type: :string,\n                  description: \"The measured skill for hunting\",\n                  default: \"lazy\",\n                  enum: [\"clueless\", \"lazy\", \"adventurous\", \"aggressive\"]\n                }\n              },\n              required: [:huntingSkill]\n            }\n          ]\n        })\n      end\n\n      defmodule Dog do\n        require OpenApiSpex\n        alias OpenApiSpex.Schema\n        OpenApiSpex.schema(%{\n          type: :object,\n          title: \"Dog\",\n          description: \"A representation of a dog. Note that `Dog` will be used as the discriminator value.\",\n          allOf: [\n            PetCommon,\n            %Schema {\n              type: :object,\n              properties: %{\n                packSize: %Schema{\n                  type: :integer,\n                  format: :int32,\n                  description: \"the size of the pack the dog is from\",\n                  default: 0,\n                  minimum: 0\n                }\n              },\n              required: [\n                :packSize\n              ]\n            }\n          ]\n        })\n      end\n\n      defmodule Pet do\n        require OpenApiSpex\n        alias OpenApiSpex.Discriminator\n        OpenApiSpex.schema(%{\n          title: \"Pet\",\n          type: :object,\n          discriminator: %Discriminator{\n            propertyName: \"petType\"\n          },\n          oneOf: [\n            Cat,\n            Dog\n          ]\n        })\n      end\n    end","ref":"OpenApiSpex.Schema.html#module-examples","title":"Examples - OpenApiSpex.Schema","type":"behaviour"},{"doc":"Cast a simple value to the elixir type defined by a schema.\n\nBy default, object types are cast to maps, however if the \"x-struct\" attribute is set in the schema,\nthe result will be constructed as an instance of the given struct type.","ref":"OpenApiSpex.Schema.html#cast/3","title":"OpenApiSpex.Schema.cast/3","type":"function"},{"doc":"iex> OpenApiSpex.Schema.cast(%Schema{type: :integer}, \"123\", %{})\n    {:ok, 123}\n\n    iex> {:ok, dt = %DateTime{}} = OpenApiSpex.Schema.cast(%Schema{type: :string, format: :\"date-time\"}, \"2018-04-02T13:44:55Z\", %{})\n    ...> dt |> DateTime.to_iso8601()\n    \"2018-04-02T13:44:55Z\"","ref":"OpenApiSpex.Schema.html#cast/3-examples","title":"Examples - OpenApiSpex.Schema.cast/3","type":"function"},{"doc":"Schemas using `discriminator`, `allOf`, `oneOf`, `anyOf` are cast using the following rules:\n\n  - If a `discriminator` is present, cast the properties defined in the base schema, then\n    cast the result using the schema identified by the discriminator. To avoid infinite recursion,\n    the discriminator is only dereferenced if the discriminator property has not already been cast.\n\n  - Cast the properties using each schema listing in `allOf`. When a property is defined in\n    multiple `allOf` schemas, it will be cast using the first schema listed containing the property.\n\n  - Cast the value using each schema listed in `oneOf`, stopping as soon as a successful cast is made.\n\n  - Cast the value using each schema listed in `anyOf`, stopping as soon as a successful cast is made.","ref":"OpenApiSpex.Schema.html#cast/3-casting-polymorphic-schemas","title":"Casting Polymorphic Schemas - OpenApiSpex.Schema.cast/3","type":"function"},{"doc":"Generate example value from a `%Schema{}` struct.\n\nThis is useful as a simple way to generate values for tests.\n\nExample:\n\n    test \"create user\", %{conn: conn} do\n      user_request_schema = MyAppWeb.Schemas.UserRequest.schema()\n      req_body = OpenApiSpex.Schema.example(user_request_schema)\n\n      resp_body =\n        conn\n        |> post(\"/users\", req_body)\n        |> json_response(201)\n\n      assert ...\n    end","ref":"OpenApiSpex.Schema.html#example/1","title":"OpenApiSpex.Schema.example/1","type":"function"},{"doc":"Generate example value from a `OpenApiSpex.Schema` or a `OpenApiSpex.Reference` struct.\n\nThe second parameter must either be an `OpenApiSpex.OpenApi` struct or a map of schemas.\n\nSee also: `example/1`.","ref":"OpenApiSpex.Schema.html#example/2","title":"OpenApiSpex.Schema.example/2","type":"function"},{"doc":"Get the names of all properties defined for a schema.\n\nIncludes all properties directly defined in the schema, and all schemas\nincluded in the `allOf` list.","ref":"OpenApiSpex.Schema.html#properties/1","title":"OpenApiSpex.Schema.properties/1","type":"function"},{"doc":"A module implementing the `OpenApiSpex.Schema` behaviour should export a `schema/0` function\nthat produces an `OpenApiSpex.Schema` struct.","ref":"OpenApiSpex.Schema.html#c:schema/0","title":"OpenApiSpex.Schema.schema/0","type":"callback"},{"doc":"Validate a value against a Schema.\n\nThis expects that the value has already been `cast` to the appropriate data type.","ref":"OpenApiSpex.Schema.html#validate/3","title":"OpenApiSpex.Schema.validate/3","type":"function"},{"doc":"iex> OpenApiSpex.Schema.validate(%OpenApiSpex.Schema{type: :integer, minimum: 5}, 3, %{})\n    {:error, \"#: 3 is smaller than minimum 5\"}\n\n    iex> OpenApiSpex.Schema.validate(%OpenApiSpex.Schema{type: :string, pattern: \"(.*)@(.*)\"}, \"joe@gmail.com\", %{})\n    :ok\n\n    iex> OpenApiSpex.Schema.validate(%OpenApiSpex.Schema{type: :string, pattern: \"(.*)@(.*)\"}, \"joegmail.com\", %{})\n    {:error, \"#: Value \\\"joegmail.com\\\" does not match pattern: (.*)@(.*)\"}","ref":"OpenApiSpex.Schema.html#validate/3-examples","title":"Examples - OpenApiSpex.Schema.validate/3","type":"function"},{"doc":"","ref":"OpenApiSpex.Schema.html#validate/4","title":"OpenApiSpex.Schema.validate/4","type":"function"},{"doc":"The basic data types supported by openapi.\n\n[Reference](https://swagger.io/docs/specification/data-models/data-types/)","ref":"OpenApiSpex.Schema.html#t:data_type/0","title":"OpenApiSpex.Schema.data_type/0","type":"type"},{"doc":"Global schemas lookup by name.","ref":"OpenApiSpex.Schema.html#t:schemas/0","title":"OpenApiSpex.Schema.schemas/0","type":"type"},{"doc":"[Schema Object](https://swagger.io/specification/#schemaObject)\n\nThe Schema Object allows the definition of input and output data types.\nThese types can be objects, but also primitives and arrays.\nThis object is an extended subset of the JSON Schema Specification Wright Draft 00.","ref":"OpenApiSpex.Schema.html#t:t/0","title":"OpenApiSpex.Schema.t/0","type":"type"},{"doc":"alias OpenApiSpex.Schema\n\n    %Schema{\n      title: \"User\",\n      type: :object,\n      properties: %{\n        id: %Schema{type: :integer, minimum: 1},\n        name: %Schema{type: :string, pattern: \"[a-zA-Z][a-zA-Z0-9_]+\"},\n        email: %Schema{type: :string, format: :email},\n        last_login: %Schema{type: :string, format: :\"date-time\"}\n      },\n      required: [:name, :email],\n      example: %{\n        \"name\" => \"joe\",\n        \"email\" => \"joe@gmail.com\"\n      }\n    }","ref":"OpenApiSpex.Schema.html#t:t/0-example","title":"Example - OpenApiSpex.Schema.t/0","type":"type"},{"doc":"Rules of API Schema consistency.\nIf these rules are not followed, tricky run-time bugs may appear.\nRelated issues: #144","ref":"OpenApiSpex.SchemaConsistency.html","title":"OpenApiSpex.SchemaConsistency","type":"module"},{"doc":"Returns a list of compile-time warnings","ref":"OpenApiSpex.SchemaConsistency.html#warnings/1","title":"OpenApiSpex.SchemaConsistency.warnings/1","type":"function"},{"doc":"Internal module used to resolve `OpenApiSpex.Schema` structs from atoms.","ref":"OpenApiSpex.SchemaResolver.html","title":"OpenApiSpex.SchemaResolver","type":"module"},{"doc":"Adds schemas to the api spec from the modules specified in the Operations.\n\nEg, if the response schema for an operation is defined with:\n\n    responses: %{\n      200 => Operation.response(\"User\", \"application/json\", UserResponse)\n    }\n\nThen the `UserResponse.schema()` function will be called to load the schema, and\na `Reference` to the loaded schema will be used in the operation response.\n\nSee `OpenApiSpex.schema` macro for a convenient syntax for defining schema modules.","ref":"OpenApiSpex.SchemaResolver.html#resolve_schema_modules/1","title":"OpenApiSpex.SchemaResolver.resolve_schema_modules/1","type":"function"},{"doc":"Defines the `OpenApiSpex.SecurityRequirement.t` type.","ref":"OpenApiSpex.SecurityRequirement.html","title":"OpenApiSpex.SecurityRequirement","type":"module"},{"doc":"[Security Requirement Object](https://swagger.io/specification/#securityRequirementObject)\n\nLists the required security schemes to execute this operation.\nThe name used for each property MUST correspond to a security scheme declared in the Security Schemes under the Components Object.\nSecurity Requirement Objects that contain multiple schemes require that all schemes MUST be satisfied for a request to be authorized.\nThis enables support for scenarios where multiple query parameters or HTTP headers are required to convey security information.\nWhen a list of Security Requirement Objects is defined on the Open API object or Operation Object,\nonly one of Security Requirement Objects in the list needs to be satisfied to authorize the request.","ref":"OpenApiSpex.SecurityRequirement.html#t:t/0","title":"OpenApiSpex.SecurityRequirement.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.SecurityScheme.t` type.","ref":"OpenApiSpex.SecurityScheme.html","title":"OpenApiSpex.SecurityScheme","type":"module"},{"doc":"[Security Scheme Object](https://swagger.io/specification/#securitySchemeObject)\n\nDefines a security scheme that can be used by the operations.\nSupported schemes are HTTP authentication, an API key (either as a header or as a query parameter),\nOAuth2's common flows (implicit, password, application and access code) as defined in RFC6749, and OpenID Connect Discovery.","ref":"OpenApiSpex.SecurityScheme.html#t:t/0","title":"OpenApiSpex.SecurityScheme.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Server.t` type.","ref":"OpenApiSpex.Server.html","title":"OpenApiSpex.Server","type":"module"},{"doc":"Builds a Server from a phoenix Endpoint module","ref":"OpenApiSpex.Server.html#from_endpoint/1","title":"OpenApiSpex.Server.from_endpoint/1","type":"function"},{"doc":"Builds a Server from a phoenix Endpoint module","ref":"OpenApiSpex.Server.html#from_endpoint/2","title":"OpenApiSpex.Server.from_endpoint/2","type":"function"},{"doc":"[Server Object](https://swagger.io/specification/#serverObject)\n\nAn object representing a Server.","ref":"OpenApiSpex.Server.html#t:t/0","title":"OpenApiSpex.Server.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.ServerVariable.t` type.","ref":"OpenApiSpex.ServerVariable.html","title":"OpenApiSpex.ServerVariable","type":"module"},{"doc":"[Server Variable Object](https://swagger.io/specification/#serverVariableObject)\n\nAn object representing a Server Variable for server URL template substitution.","ref":"OpenApiSpex.ServerVariable.html#t:t/0","title":"OpenApiSpex.ServerVariable.t/0","type":"type"},{"doc":"Defines the `OpenApiSpex.Tag.t` type.","ref":"OpenApiSpex.Tag.html","title":"OpenApiSpex.Tag","type":"module"},{"doc":"[Tag Object](https://swagger.io/specification/#tagObject)\n\nAdds metadata to a single tag that is used by the Operation Object.\nIt is not mandatory to have a Tag Object per tag defined in the Operation Object instances.","ref":"OpenApiSpex.Tag.html#t:t/0","title":"OpenApiSpex.Tag.t/0","type":"type"},{"doc":"Defines helpers for testing API responses and examples against API spec schemas.","ref":"OpenApiSpex.Test.Assertions.html","title":"OpenApiSpex.Test.Assertions","type":"module"},{"doc":"Asserts that `value` conforms to the schema with title `schema_title` in `api_spec`.","ref":"OpenApiSpex.Test.Assertions.html#assert_schema/3","title":"OpenApiSpex.Test.Assertions.assert_schema/3","type":"function"},{"doc":"Defines helpers for testing API responses and examples against API spec schemas.","ref":"OpenApiSpex.Test.Assertions2.html","title":"OpenApiSpex.Test.Assertions2","type":"module"},{"doc":"Asserts that `value` conforms to the schema with title `schema_title` in `api_spec`.","ref":"OpenApiSpex.Test.Assertions2.html#assert_schema/3","title":"OpenApiSpex.Test.Assertions2.assert_schema/3","type":"function"},{"doc":"Defines helpers for testing API responses and examples against API spec schemas.","ref":"OpenApiSpex.TestAssertions.html","title":"OpenApiSpex.TestAssertions","type":"module"},{"doc":"Asserts that the response body conforms to the response schema for the operation with id `operation_id`.","ref":"OpenApiSpex.TestAssertions.html#assert_operation_response/2","title":"OpenApiSpex.TestAssertions.assert_operation_response/2","type":"function"},{"doc":"Asserts that `value` conforms to the schema or reference definition.","ref":"OpenApiSpex.TestAssertions.html#assert_raw_schema/3","title":"OpenApiSpex.TestAssertions.assert_raw_schema/3","type":"function"},{"doc":"Asserts that `value` is a valid **request** schema with title `schema_title` in `api_spec`. In this case,\nthe presence of required `readOnly` fields is not validated.","ref":"OpenApiSpex.TestAssertions.html#assert_request_schema/3","title":"OpenApiSpex.TestAssertions.assert_request_schema/3","type":"function"},{"doc":"Asserts that `value` is a valid **response** schema with title `schema_title` in `api_spec`. In this case,\nthe presence of required `writeOnly` fields is not validated.","ref":"OpenApiSpex.TestAssertions.html#assert_response_schema/3","title":"OpenApiSpex.TestAssertions.assert_response_schema/3","type":"function"},{"doc":"Asserts that `value` conforms to the schema in the given `%Cast{}` context.","ref":"OpenApiSpex.TestAssertions.html#assert_schema/1","title":"OpenApiSpex.TestAssertions.assert_schema/1","type":"function"},{"doc":"Asserts that `value` conforms to the schema with title `schema_title` in `api_spec`.","ref":"OpenApiSpex.TestAssertions.html#assert_schema/4","title":"OpenApiSpex.TestAssertions.assert_schema/4","type":"function"},{"doc":"Defines the `OpenApiSpex.Xml.t` type.","ref":"OpenApiSpex.Xml.html","title":"OpenApiSpex.Xml","type":"module"},{"doc":"[XML Object](https://swagger.io/specification/#xmlObject)\n\nA metadata object that allows for more fine-tuned XML model definitions.\nWhen using arrays, XML element names are not inferred (for singular/plural forms)\nand the name property SHOULD be used to add that information. See examples for expected behavior.","ref":"OpenApiSpex.Xml.html#t:t/0","title":"OpenApiSpex.Xml.t/0","type":"type"},{"doc":"","ref":"OpenApiSpex.SchemaException.html","title":"OpenApiSpex.SchemaException","type":"exception"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* Update dev dependencies and example apps by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/624\n* Support casting decimals by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/634\n* Support decoding operations with :servers. by @loguntsov in https://github.com/open-api-spex/open_api_spex/pull/635","ref":"changelog.html#v3-21-0-2024-09-12","title":"v3.21.0 - 2024-09-12 - Changelog","type":"extras"},{"doc":"* Support custom error messages in custom validators by @GregorGrasselli in https://github.com/open-api-spex/open_api_spex/pull/621\n* Update Schema.example/2 typespec to allow references by @zorbash in 5ec452f","ref":"changelog.html#v3-20-1-2024-07-31","title":"v3.20.1 - 2024-07-31 - Changelog","type":"extras"},{"doc":"* Respect minLength when generating string examples by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/608\n* Accept read_write_scope from opts when calling cast functions directly by @albertored in https://github.com/open-api-spex/open_api_spex/pull/572\n* Allow Poison v6 to be used by @hkrutzer in https://github.com/open-api-spex/open_api_spex/pull/616\n* chore: Drop build matrix support for elixir 1.11, 1.12, 1.13 and OTP 22 by @mbuhot in https://github.com/open-api-spex/open_api_spex/pull/619\n* improvement: use struct spec to avoid double `%` in struct inspect by @zachdaniel in https://github.com/open-api-spex/open_api_spex/pull/613\n* Feat: add `--check` option in Mix tasks to compare the generated spec with a previously generated file by @davidebriani in https://github.com/open-api-spex/open_api_spex/pull/618\n* fix: cast numbers as floats by @David-Klemenc in https://github.com/open-api-spex/open_api_spex/pull/611","ref":"changelog.html#v3-20-0-2024-07-10","title":"v3.20.0 - 2024-07-10 - Changelog","type":"extras"},{"doc":"* Add notice that body params are not merged into Conn.params whne using cast and validate plug by @hamir-suspect in #589\n* Set nonces on ` ` and ` ` elements if configured by @nathanalderson in #593\n* Ensure operation_id is always set on conn.private by @msutkowski in #606","ref":"changelog.html#v3-19-1-2024-05-17","title":"v3.19.1 - 2024-05-17 - Changelog","type":"extras"},{"doc":"* Support response code ranges by @zorbash in 8898859da1","ref":"changelog.html#v3-19-0-2024-04-30","title":"v3.19.0 - 2024-04-30 - Changelog","type":"extras"},{"doc":"* Relax dependency constraint on ymlr to allow version ~> 5.0 by @egze in https://github.com/open-api-spex/open_api_spex/pull/586","ref":"changelog.html#v3-18-3-2024-03-15","title":"v3.18.3 - 2024-03-15 - Changelog","type":"extras"},{"doc":"* Fix 'AllOf cast returns a map, but I expected a struct' by @angelikatyborska in https://github.com/open-api-spex/open_api_spex/pull/592","ref":"changelog.html#v3-18-2-2024-01-26","title":"v3.18.2 - 2024-01-26 - Changelog","type":"extras"},{"doc":"* Fix `assert_operation_response/2` header lookup by @msutkowski in https://github.com/open-api-spex/open_api_spex/pull/584\n* Exclude empty paths (`operation false`) from generated spec by @alisinabh in https://github.com/open-api-spex/open_api_spex/pull/583\n* Cast discriminator when no title present (#574) by @albertored in https://github.com/open-api-spex/open_api_spex/pull/574\n* Docstest Operation.parameter/5 by @zorbash\n* Document the spec export task `--filename` option by @zorbash","ref":"changelog.html#v3-18-1-2023-12-19","title":"v3.18.1 - 2023-12-19 - Changelog","type":"extras"},{"doc":"* Relax dependency constraint on ymlr to allow version ~> 4.0 by @arcanemachine in https://github.com/open-api-spex/open_api_spex/pull/544\n* Fix deprecation warning on Elixir 1.15, require Elixir 1.11, adapt CI by @thbar in https://github.com/open-api-spex/open_api_spex/pull/550\n* Add `--quiet` option for spec generation by @Cowa in https://github.com/open-api-spex/open_api_spex/pull/557\n* Fix casting non-objects against discriminator #551 by @gianluca-nitti in https://github.com/open-api-spex/open_api_spex/pull/552\n* feat: add assert_operation_response, assert_raw_schema by @msutkowski in https://github.com/open-api-spex/open_api_spex/pull/545","ref":"changelog.html#v3-18-0-2023-08-23","title":"v3.18.0 - 2023-08-23 - Changelog","type":"extras"},{"doc":"* Raise meaningful error message when `SchemaResolver.resolve_schema_modules_from_schema` failed to pattern match by @yuchunc in https://github.com/open-api-spex/open_api_spex/pull/541\n* Support structs as inputs when casting objects by @gianluca-nitti in https://github.com/open-api-spex/open_api_spex/pull/529\n* Fix #540 `PathItem.from_routes/1` dialyzer warnings - @zorbash - 055c8e0131a4f8","ref":"changelog.html#v3-17-3-2023-05-30","title":"v3.17.3 - 2023-05-30 - Changelog","type":"extras"},{"doc":"* Fix `Schema.example/2` for `anyOf` - @zorbash - 3046c68","ref":"changelog.html#v3-17-2-2023-05-26","title":"v3.17.2 - 2023-05-26 - Changelog","type":"extras"},{"doc":"* Add missing `Reference.resolve_response/2` - @zorbash - a5bd81dac","ref":"changelog.html#v3-17-1-2023-05-22","title":"v3.17.1 - 2023-05-22 - Changelog","type":"extras"},{"doc":"* Support passing a `%Reference{}` as a response when doing controller specs by @mracos in https://github.com/open-api-spex/open_api_spex/pull/532\n* Implement `OpenApiSpex.Schema.example/2` which resolves references - @zorbash - 45a26f045776","ref":"changelog.html#v3-17-0-2023-05-18","title":"v3.17.0 - 2023-05-18 - Changelog","type":"extras"},{"doc":"* Ensure schemas with discriminator work with atom-keyed maps - a7b8067a7a\n* Ensure spec decoding converts `required` items into atoms for `allOf` / `anyOf` / `oneOf` - a7b8067a7a","ref":"changelog.html#v3-16-4-2023-05-17","title":"v3.16.4- 2023-05-17 - Changelog","type":"extras"},{"doc":"* Keep discriminator errors relevant by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/533\n* Avoid compile time dependencies by @doorgan in https://github.com/open-api-spex/open_api_spex/pull/536","ref":"changelog.html#v3-16-3-2023-05-02","title":"v3.16.3 - 2023-05-02 - Changelog","type":"extras"},{"doc":"* Infer moduledoc from schema by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/525\n* Fix typespec and add example to Paths.from_routes/1 by @thiagogsr in https://github.com/open-api-spex/open_api_spex/pull/534","ref":"changelog.html#v3-16-2-2023-04-13","title":"v3.16.2 - 2023-04-13 - Changelog","type":"extras"},{"doc":"* Accept dates and datetimes in formatted string schemas by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/524","ref":"changelog.html#v3-16-1-2023-02-07","title":"v3.16.1 - 2023-02-07 - Changelog","type":"extras"},{"doc":"* Optimise property counting for object validations by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/514\n* Omit required from schemas when list is empty by @mbuhot in https://github.com/open-api-spex/open_api_spex/pull/515","ref":"changelog.html#v3-16-0-2022-11-23","title":"v3.16.0 - 2022-11-23 - Changelog","type":"extras"},{"doc":"* Resolve schema modules in discriminator mapping by @mbuhot in https://github.com/open-api-spex/open_api_spex/pull/511","ref":"changelog.html#v3-15-0-2022-11-02","title":"v3.15.0 - 2022-11-02 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community\n\n- [@zorbash](https://github.com/zorbash)\n- [@thbar](https://github.com/thbar)\n- [@gmile](https://github.com/gmile)\n- [@lucacorti](https://github.com/lucacorti)\n\n* Enhancement: Allow casting atoms as strings by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/497\n* Fix: Relax dependency constraint on ymlr by @thbar in https://github.com/open-api-spex/open_api_spex/pull/502\n* Enhancement: Implement casting of \"byte\" string type by @gmile in https://github.com/open-api-spex/open_api_spex/pull/504\n* Enhancement: Make OpenApiSpex.resolve_schema/2 work with schema modules by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/458\n* Fix: Fix oneOf/allOf/anyOf and schema module in Discriminator mapping by @lucacorti in https://github.com/open-api-spex/open_api_spex/pull/455","ref":"changelog.html#v3-14-0-2022-10-23","title":"v3.14.0 - 2022-10-23 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community\n\n- [@MichalDolata](https://github.com/MichalDolata)\n- [@mbuhot](https://github.com/mbuhot)\n- [@zorbash](https://github.com/zorbash)\n- [@albertored](https://github.com/albertored)\n- [@rolandtritsch](https://github.com/rolandtritsch)\n- [@natali-maximenko](https://github.com/natali-maximenko)\n- [@Eein](https://github.com/Eein)\n\n* Docs: Document OpenApiSpex.Plug.NoneCache #480 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/480\n* Enhancement: Improve example apps #481 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/481\n* Infrastructure: Fix CI workflow  by @mbuhot\n* Enhancement: Fix compilation warnings #479 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/479\n* Enhancement: Allow to configure casting to not automatically populate default values #460 by @albertored in https://github.com/open-api-spex/open_api_spex/pull/460\n* Fix: (UndefinedFunctionError) #447 by @rolandtritsch in https://github.com/open-api-spex/open_api_spex/pull/447\n* Enhancement: Allow omitting parens in test assertion functions #485 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/485\n* Fix: `not` schemas not decoded correctly #484 by @albertored in https://github.com/open-api-spex/open_api_spex/pull/484\n* Enhancement: Add `--start-app` option in openapi generation task #489 by @natali-maximenko in https://github.com/open-api-spex/open_api_spex/pull/489\n* Enhancement: Loosen poison dependency to allow using version 3.0 #483 by @Eein in https://github.com/open-api-spex/open_api_spex/pull/483\n* Enhancement: Bump swagger-ui JS dependency to 4.14.0 by @zorbash\n\n**Full Changelog**: https://github.com/open-api-spex/open_api_spex/compare/v3.12.0...v3.13.0","ref":"changelog.html#v3-13-0-2022-09-24","title":"v3.13.0 - 2022-09-24 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community\n\n- [@pxp9](https://github.com/pxp9)\n- [@tfwright](https://github.com/tfwright)\n- [@juantascon](https://github.com/juantascon)\n- [@riccardomanfrin](https://github.com/riccardomanfrin)\n- [@rogerweb](https://github.com/rogerweb)\n- [@zorbash](https://github.com/zorbash)\n- [@gianluca-nitti](https://github.com/nitti)\n- [@MichalDolata](https://github.com/MichalDolata)\n- [@Geekfish](https://github.com/Geekfish)\n- [@lazebny](https://github.com/lazebny)\n- [@Eein](https://github.com/Eein)\n\n* Docs: Solve Issue #396 by @pxp9 in https://github.com/open-api-spex/open_api_spex/pull/397\n* Docs: Clarify controller example by @tfwright in https://github.com/open-api-spex/open_api_spex/pull/405\n* Fix: Consider one-shot additionalProperties in .decode() by @zoten in https://github.com/open-api-spex/open_api_spex/pull/413\n* Fix: Casting Encoding without style field by @juantascon in https://github.com/open-api-spex/open_api_spex/pull/395\n* Fix: Adds responses dereferencing by @riccardomanfrin in https://github.com/open-api-spex/open_api_spex/pull/400\n* Docs: Fix typos by @kianmeng in https://github.com/open-api-spex/open_api_spex/pull/414\n* Enhancement: Implement Extendable protocol for all structs that can have extensions by @albertored in https://github.com/open-api-spex/open_api_spex/pull/415\n* Fix: decode/1 function correctly populates the :extensions field of structs by @albertored in https://github.com/open-api-spex/open_api_spex/pull/416\n* Fix: Allow empty schemas to be validated as wildcards by @zoten in https://github.com/open-api-spex/open_api_spex/pull/419\n* Docs: Fix schema example minor syntax issues (#431) by @rogerweb in https://github.com/open-api-spex/open_api_spex/pull/433\n* Enhancement: Bump swagger_ui version to 4.6.2 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/437\n* Enhancement: Implement flag to omit vendor extensions in mix openapi.spec.json by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/439\n* Enhancement: Generate examples for UUID formatted strings by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/444\n* Enhancement: Format code with mix format by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/449\n* Docs: Fix typo in result of JsonErrorResponse.response() by @gianluca-nitti in https://github.com/open-api-spex/open_api_spex/pull/448\n* Fix: Avoids overwriting Plug.Conn body_params and params with the cast outcome by @albertored in https://github.com/open-api-spex/open_api_spex/pull/425\n* Enhancement: Multiple content types by @moxley in https://github.com/open-api-spex/open_api_spex/pull/451\n* Fix: llow empty content for Response by @MichalDolata in https://github.com/open-api-spex/open_api_spex/pull/453\n* Infrastructure: Improve CI pipeline by @lucacorti in https://github.com/open-api-spex/open_api_spex/pull/377\n* Fix: upport RequestBody passed to operation macro by @Geekfish in https://github.com/open-api-spex/open_api_spex/pull/456\n* Enhancement: Allow extensions in all OpenApi structures by @albertored in https://github.com/open-api-spex/open_api_spex/pull/438\n* Enhancement: ast parameters with json content-type by @albertored in https://github.com/open-api-spex/open_api_spex/pull/445\n* Docs: Code formatting in README by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/459\n* Validate :integer type format by @wingyplus in https://github.com/open-api-spex/open_api_spex/pull/465\n* Fix: Do not accepting float number in integer type by @wingyplus in https://github.com/open-api-spex/open_api_spex/pull/468\n* Fix: anyOf cast crash when Cast.cast return a struct by @wingyplus in https://github.com/open-api-spex/open_api_spex/pull/469\n* Fix: Decoding of discriminators when `type: object` is present by @albertored in https://github.com/open-api-spex/open_api_spex/pull/471\n* Fix: Correctly cast not map bodies (plug puts them under _json key) by @albertored in https://github.com/open-api-spex/open_api_spex/pull/470\n* Enhancement: Add YAML formatter #463 by @lazebny in https://github.com/open-api-spex/open_api_spex/pull/464\n* Enhancement: use cache adapter at runtime instead of compile time for PutApiSpec by @Eein in https://github.com/open-api-spex/open_api_spex/pull/461\n* Infrastructure: Build and publish a hex.pm package automatically by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/474\n\n**Full Changelog**: https://github.com/open-api-spex/open_api_spex/compare/v3.11.0...v3.12.0","ref":"changelog.html#v3-12-0-2022-07-21","title":"v3.12.0 - 2022-07-21 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [@asppsa](https://github.com/asppsa)\n- [@ElijahBrandyberry](https://github.com/ElijahBrandyberry)\n- [@kianmeng](https://github.com/kianmeng)\n- [@lucacorti](https://github.com/lucacorti)\n- [@m0rt3nlund](https://github.com/m0rt3nlund)\n- [@mbuhot](https://github.com/mbuhot)\n- [@moxley](https://github.com/moxley)\n- [@nimish-mehta](https://github.com/nimish)\n- [@reneweteling](https://github.com/reneweteling)\n- [@stefanluptak](https://github.com/stefanluptak)\n- [@vitorbortolotti](https://github.com/vitorbortolotti)\n- [@vorce](https://github.com/vorce)\n- [@ycherniavskyi](https://github.com/ycherniavskyi)\n- [@zoten](https://github.com/zoten)\n- [seantanly](https://github.com/eantanly)\n\n* Docs: Fix Application.spec/2 example in README #344\n* Docs: Misc doc changes (#355)\n* Docs: JsonApiErrorResponse vs JsonErrorResponse (#385)\n* Enhancement: Allow casting params where parameter.content schema is a Reference (#356)\n* Enhancement: external_docs via controller @doc and @moduledoc or ControllerSpecs DSL (#329)\n* Enhancement: Add optional header in opts to Operation.response (#332)\n* Enhancement: Add callback support to operation_spec (#345)\n* Enhancement: Adding helpers to OpenApiSpex.TestAssertions (#343)\n* Enhancement: Collect all errors occurred during cast properties (#354)\n* Enhancement: Add support for multiple specs for the same Phoenix router (#369)\n* Enhancement: updated swagger-ui to 3.34.0 (#378)\n* Fix casting additionalProperties (#386)\n* Fix JsonErrorResponse schema definition (#383)\n* Fix: test for cast of query parameters with style: form and explode: false (#364)\n* Fix: any_of cast for multiple schemas (#366)\n* Fix: Handle oneOf cast when there are multiple success along with failure (#362)\n* Fix: Casting of additionalProperties with references (#360)\n* Fix: Schema.example/1 for schema module (#358)\n* Fix: Stop circular dependency by injecting the schema into list of already processed schemas (#352)\n* Fix: Cast default for referenced schema (#337)\n* Fix: don't json encode swagger-ui methods (#325)\n* Fix: relax requirement on poison preventing version conflicts in library usage (#322)\n* Fix: Allow top level security to apply to operations #321\n* Fix: return error tuple when discriminator cast fails (#393)\n* Infrastructure: Run Elixir CI with GitHub Actions (#347)","ref":"changelog.html#v3-11-0-2021-10-29","title":"v3.11.0 - 2021-10-29 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [noozo](https://github.com/noozo)\n- [sernajoto](https://github.com/sernajoto)\n- [pacoguzman](https://github.com/pacoguzman)\n- [vitorleal](https://github.com/vitorleal)\n- [zlarsen](https://github.com/zlarsen)\n- [surik](https://github.com/surik)\n- [brentjr](https://github.com/brentjr)\n- [dwmcc](https://github.com/dwmcc)\n- [wingyplus](https://github.com/wingyplus)\n\n* Feature: Support OAuth2 for swagger-ui (#217)\n* Feature: Support `default` response type in responses (#301)\n* Feature: Allow overriding `x*struct` in `OpenApiSpex.schema/1` (#304)\n* Feature: Ability to specify `deprecated` in ControllerSpec operation (#296)\n* Feature: `:struct?` and `:derive?` options in `OpenApiSpex.schema/1` (#312)\n* Feature: `OpenApiSpex.add_schemas/2` (#314)\n* Enhancement: Remove api_spec data from Conn (#286)\n* Enhancement: More informative errors for bad schema (#288, #284, #287)\n* Fix: Convert `:format` value to atom when decoding schema file (#293)\n* Fix: Type spec in OpenApiSpex.Info\n* Fix: Elixir Formatter rules in published package (#306)\n* Docs: Fix spelling error in example code (#295)\n* Docs: Fix type in README (#297)\n* Docs: Fix links and punctuation in README (#298)\n* Docs: Promote ControlerSpecs as the preferred API for controller operations (#311)","ref":"changelog.html#v3-10-0-2021-01-11","title":"v3.10.0 - 2021-01-11 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [feng19](https://github.com/feng19)\n- [jbernardo95](https://github.com/jbernardo95)\n\n* Feature: Generate example from schema (#266)\n* Feature: Allow SwaggerUI to be configured via Plug opts (#271)\n* Feature: Warn on invalid or missing operation specs (#273, #278)\n* Feature: Experimental alternative API for defining Operation specs (#265, #280)\n* Fix: Handle the same operation occurring at different routes (#272)\n* Fix: Casting header names that have upper case letters in specs (#281)\n* Maint: Upgrade Elixir dependencies in example projects (#269)\n* Maint: Format project with Elixir Formatter (#279)","ref":"changelog.html#v3-9-0-2020-09-14","title":"v3.9.0 - 2020-09-14 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [feng19](https://github.com/feng19)\n- [gdiasdasilva](https://github.com/gdiasdasilva)\n- [mojidabckuu](https://github.com/mojidabckuu)\n- [noozo](https://github.com/noozo)\n- [Shikanime](https://github.com/Shikanime)\n- [slashdotdash](https://github.com/slashdotdash)\n- [velimir](https://github.com/velimir)\n- [wardes](https://github.com/wardes)\n\n* Feature: Custom validators (#243)\n* Feature: Swagger json generation Mix Task (#249)\n* Feature: Customizable cache adapter (#262)\n* Enhancement: Allow passsing `false` to `@doc` annotation to skip the warning. (#236)\n* Enhancement: Make @doc parameters declaration consistent with open api (#237)\n* Enhancement: Support `security` `@doc` string attribute on operations (#251)\n* Enhancement: Allow a `Reference` to be used for directly in the `parameters` definition (#258)\n* Enhancement: Allow a `Reference` to be used for an Operation's request body (#260)\n* Docs: Fixes README.md responses example typo \"unprocessible\" (#248)\n* Docs: Fix security example to use correct types for the keys (#239)\n* Fix: Remove default pop value for :type shortcut in `@doc` specs (#238)\n* Fix: Nested parameters when served from file based schema (#241)\n* Fix: Error handling for oneOf (#246)\n* Fix: json:api compatible data shape option for JsonRenderError (#245)\n* Fix: ReferenceError: `components.parameter` missing `s` in CastParamters (#257)\n* Fix: struct def for custom validators (#263)","ref":"changelog.html#v3-8-0-2020-08-22","title":"v3.8.0 - 2020-08-22 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [soundmonster](https://github.com/soundmonster)\n- [slapers](https://github.com/slapers)\n- [pedroassumpcao](https://github.com/pedroassumpcao)\n- [petersenlance](https://github.com/petersenlance)\n- [mdogo](https://github.com/mdogo)\n- [minibikini](https://github.com/minibikini)\n- [rinpatch](https://github.com/rinpatch)\n- [palcalde](https://github.com/palcalde)\n\n* Enhancement: Multiple bug fixes and edge case handling of ExDoc based operation specs\n* Enhancement: Upgrade Swagger UI to 3.24.2 (#210)\n* Enhancement: Improve oneOf casting (#227)\n* Docs: Add SecurityScheme usage and examples in the readme (#215)\n* Fix: References for query params and discriminators with mappings not working (#200)\n* Fix: Errors in parameter pattern validation (#206)\n* Fix example (#212)\n* Fix: CastAndValidate: incorrect content-type handling (#218)\n* Fix: Can't cast and validate a JSON array as request body (#229)","ref":"changelog.html#v3-7-0-2020-06-05","title":"v3.7.0 - 2020-06-05 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [Zakjholt](https://github.com/Zakjholt)\n- [supermaciz](https://github.com/supermaciz)\n- [mrmstn](https://github.com/mrmstn)\n- [aisrael](https://github.com/aisrael)\n\n* Feature: Improved inspect output of `%Schema{}` (#193)\n* Feature: Auto-populate schema title from module name (#192)\n* Feature: Derive Operation ID from meta in ExDoc specs (#195)\n* Fix: Validation of array minItems ignores empty array (#179)\n* Fix: Add minimum/maximum validation for number properties (#181)\n* Fix: Properly validate header params (#184)\n* Fix: Support free-form query parameters (#171)\n* Fix: Resolve schema modules from Response in Components (#186)","ref":"changelog.html#v3-6-0-2020-02-13","title":"v3.6.0 - 2020-02-13 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [jung-hunsoo](https://github.com/jung-hunsoo)\n- [linnal](https://github.com/linnal)\n\n* Fix: Update README for Info from `Application.spec/2` (#174)\n* Fix: Casting for unsupported params (#170)","ref":"changelog.html#v3-5-2-2019-11-15","title":"v3.5.2 - 2019-11-15 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [mrmstn](https://github.com/mrmstn)\n\n* Fix: Issues with complex types for phoenix endpoints (#161)\n* Fix: In ExDoc-based operation spec (experimental), change key name used to define `requestBody` (#164)\n* Fix: `oneOf` schema having object schemas (#167)","ref":"changelog.html#v3-5-1-2019-11-10","title":"v3.5.1 - 2019-11-10 - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [surik](https://github.com/surik)\n- [fmcgeough](https://github.com/fmcgeough)\n- [zero778](https://github.com/zero778)\n- [vovayartsev](https://github.com/vovayartsev)\n- [superhawk610](https://github.com/superhawk610)\n- [jung-hunsoo](https://github.com/jung-hunsoo)\n- [supermaciz](https://github.com/supermaciz)\n- [Geekfish](https://github.com/Geekfish)\n- [mrmstn](https://github.com/mrmstn)\n- [waltfy](https://github.com/waltfy)\n- [ggpasqualino](https://github.com/ggpasqualino)\n- [hauleth](https://github.com/hauleth)\n\n* Feature: Ability to import Open API documents instead of defining them in Elixir (#152)\n* Feature: Add `display_operation_id` option to SwaggerUI (#138)\n* Feature: Schema validation: schema type required when `properties` is present (#146)\n* Feature: Improve reporting of test assertion failures (#150)\n* Feature: Support for `min_properties` validation for Object properties (#131)\n* Feature: Support property defaults in new Cast & Validate API (#145)\n* Feature: Support for casting file uploads (#133)\n* Feature: Support \"\\$ref\" in operation's parameters (#137)\n* Feature: Experimental ExDoc-based endpoint API specifications (#162)\n* Deprecation: Deprecate old cast and validation API (#153)\n* Deprecation: Set minimum supported Elixir version to 1.7, maximum 1.9 (#130)\n* Fix: Prevent example properties with nil values from being stripped out during JSON encoding (#142)\n* Fix: casting/validating of oneOf, anyOf (#148)\n* Fix: Pass additional properties through when allowed via `additionalProperties` (#155)\n* Fix: for `allOf` definitions for multi-typed `allOf` array and complex structs with inheritance (#156)\n* Fix: Allow a root-level property of compiled schema to be a schema (#158)\n* Docs: Fix bugs and improve wording in README (#126)\n* Docs: update phoenix guide and samples (#129)\n* Docs: README instructions for separating API operation from controller (#140)\n\nThe original cast & validation API has been deprecated and replaced with an API that was introduced in 3.2.0.\nUsing the old API will now result in compiler and runtime warnings.\n\nOld API:\n\n```elixir\ndefmodule PhoenixAppWeb.UserController do\n  use PhoenixAppWeb, :controller\n  plug OpenApiSpex.Plug.Cast\n  plug OpenApiSpex.Plug.Validate\nend\n```\n\nWill result in:\n\n```\nwarning: OpenApiSpex.Plug.Cast.call/2 is deprecated. Use OpenApiSpex.Plug.CastAndValidate instead\n  test/support/user_controller.ex:1\n\nwarning: OpenApiSpex.Plug.Validate.call/2 is deprecated. Use OpenApiSpex.Plug.CastAndValidate.call/2 instead\n  test/support/user_controller.ex:1\n```\n\nNew API\n\n```elixir\ndefmodule PhoenixAppWeb.UserController do\n  use PhoenixAppWeb, :controller\n  plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true\nend\n```\n\nNote that this changes the default error response. Before, it was a single, plain-text error message.\nNow, it's a list of error maps, containing more error information.\n\nOld API:\n\n```elixir\ndefmodule MyAppWeb.MyControllerTest do\n  use MyApp.ConnCase\n  # Old module\n  import OpenApiSpex.Test.Assertions","ref":"changelog.html#v3-5-0-2019-10-29","title":"v3.5.0 - 2019-10-29 - Changelog","type":"extras"},{"doc":"test \"UserController produces a UsersResponse\", %{conn: conn} do\n    api_spec = MyApp.ApiSpec.spec()\n    json =\n      conn\n      |> get(user_path(conn, :index))\n      |> json_response(200)\n\n    assert_schema(json, \"UsersResponse\", api_spec)\n  end\n\n  test \"something\" do\n    api_spec = MyApp.ApiSpec.spec()\n    schema = MyApp.Schemas.UsersResponse.schema()\n    assert_schema(schema.example, \"UsersResponse\", api_spec)\n  end\nend\n```\n\nWill produce:\n\n```\nwarning: OpenApiSpex.Test.Assertions.assert_schema/3 is deprecated. Use OpenApiSpex.TestAssertions.assert_schema/3 instead\n  test/my_controller_test.exs:21\n```\n\nNew API:\n\n```elixir\ndefmodule MyAppWeb.MyControllerTest do\n  use MyApp.ConnCase\n  # New module\n  import OpenApiSpex.TestAssertions\n\n  # The test themselves don't need to change,\n  # but the new assertion is more discerning,\n  # so it may find problems that the old API didn't.\nend\n```","ref":"changelog.html#the-test-themselves-don-t-need-to-change","title":"The test themselves don't need to change - Changelog","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡\n\n- [surik](https://github.com/surik)\n- [holsee](https://github.com/holsee)\n- [fmcgeough](https://github.com/fmcgeough)\n\n* Feature: the `OpenApiSpex` and `OpenApiSpex.Info` structs now support [extensions](https://swagger.io/docs/specification/openapi-extensions/) (#108) (#114)\n\n  The `extensions` key may contain any additional data that should be included in the info, eg the `x-logo` and `x-tagGroups` extensions:\n\n  ```elixir\n   spec = %OpenApi{\n     info: %Info{\n       title: \"Test\",\n       version: \"1.0.0\",\n       extensions: %{\n         \"x-logo\" => %{\n           \"url\" => \"https://example.com/logo.png\",\n           \"backgroundColor\" => \"#FFFFFF\",\n           \"altText\" => \"Example logo\"\n         }\n       }\n     },\n     extensions: %{\n       \"x-tagGroups\" => [\n         %{\n           \"name\" => \"Methods\",\n           \"tags\" => [\n             \"Search\",\n             \"Fetch\",\n             \"Delete\"\n           ]\n         }\n       ]\n     },\n     paths: %{ ... }\n   }\n  ```\n\n- Deprecation: `OpenApiSpex.Server.from_endpoint/2` has been deprecated in favor of `OpenApiSpex.Server.from_endpoint/1`.\n  Simply remove the `otp_app:` option from the call to use the new function. (#116)\n\n  ```elixir\n  # server = Server.from_endpoint(Endpoint, otp_app: :my_phoenix_app)\n  server = Server.from_endpoint(MyPhoenixAppWeb.Endpoint)\n  ```\n\n- Fix: The internal representation of a Phoenix Route struct changed in Phoenix 1.4.7 breaking the `OpenApiSpex.Paths.from_router/1` function. OpenApiSpex 3.4.0 will support both representations until the Phoenix API becomes stable. (#118)","ref":"changelog.html#v3-4-0-2019-06-14","title":"v3.4.0 - 2019-06-14 - Changelog","type":"extras"},{"doc":"Thanks to the contributions from the community! 👍\n\n- [hauleth](https://github.com/hauleth)\n- [cstaud](https://github.com/cstaud)\n- [xadhoom](https://github.com/xadhoom)\n- [nurugger07](https://github.com/nurugger07)\n- [fenollp](https://github.com/fenollp)\n- [moxley](https://github.com/moxley)\n\n* Feature: Enums expressed as atoms or atom-keyed maps can be cast from strings (or string-keyed maps). (#60) (#101)\n\n  Example:\n\n  ```elixir\n  parameters: [\n    Operation.parameter(:sort, :query, :string, \"sort direction\", enum: [:asc, :desc])\n  ],\n  ```\n\n- Fix: Schema module references are resolved in in-line parameter/response schemas. (#77) (#105)\n\n  Example: The response schema is given in-line as an array, but items are resolved from the `User` module.\n\n  ```elixir\n  responses: %{\n    200 => Operation.response(\n      \"User array\",\n      \"application/json\",\n      %Schema{\n        type: :array,\n        items: MyApp.Schemas.User\n      }\n    )\n  }\n  ```\n\n- Fix: Ensure integer query parameters are validated correctly after conversion from string. (#106)\n- Fix: Ensure integers are validated correctly against schema `minimum`, `maximum`, `exlcusiveMinimum` and `exclusiveMaximum` attributes. (#97)\n- Fix: Ensure strings are cast to `Date` or `DateTime` types when the schema format is `:date` or `:date-time`. (#90) (#94)\n- Docs: The contract for module supplied to the `PutApiSpec` plug is now documented by the `OpenApi` behaviour. (#73) (#103)\n- Docs: Poison replaced with Jason in example and tests (#104)\n- Docs: Improved documentation for combined `CastAndValidate` plug. (#91)\n- Internals: Cache mapping from phoenix controller/action to OpenApi operation. (#102)","ref":"changelog.html#v3-3-0-2019-05-05","title":"v3.3.0 - 2019-05-05 - Changelog","type":"extras"},{"doc":"Patch release for documentation updates and improved error rendering Plug when using `CastAndValidate`.\n\nThanks [moxley](https://github.com/moxley)!\n\n- Cast and validate guide (#89)","ref":"changelog.html#v3-2-1-2019-03-11","title":"v3.2.1 - 2019-03-11 - Changelog","type":"extras"},{"doc":"This release contains many improvements and internal changes thanks to the contributions of the community!\n\n- [moxley](https://github.com/moxley)\n- [kpanic](https://github.com/kpanic)\n- [hauleth](https://github.com/hauleth)\n- [nurugger07](https://github.com/nurugger07)\n- [ggpasqualino](https://github.com/ggpasqualino)\n- [teamon](https://github.com/teamon)\n- [bryannaegele](https://github.com/bryannaegele)\n\n* Feature: Send Plug CSRF token in x-csrf-token header from Swagger UI (#82)\n* Feature: Support `Jason` library for JSON serialization (#75)\n* Feature: Combine casting and validation into a single `CastAndValidate` Plug (#69) (#86)\n* Feature: Improved performance by avoiding copying of API Spec data in each request (#83)\n* Fix: Convert `integers` to `float` when casting to `number` type (#81) (#84)\n* Fix: Validate strings without trimming whitespace first (#79)\n* Fix: Exclusive Minimum and Exclusive maximum are validated correctly (#68)\n* Fix: Report errors when unable to convert to the expected number/string/boolean type (#64)\n* Fix: Gracefully report error when failing to convert request params to an object type (#63)\n* Internals: Improved code organisation of unit test suite (#62)","ref":"changelog.html#v3-2-0-2019-03-10","title":"v3.2.0 - 2019-03-10 - Changelog","type":"extras"},{"doc":"- Add support for validating polymorphic schemas using `oneOf`, `anyOf`, `allOf`, `not` constructs.\n- Updated example apps to work with new API\n- CI has moved from travis-ci.org to travis-ci.com and now uses github apps integration.\n\nThanks to [fenollp](https://github.com/fenollp) and [tapickell](https://github.com/tapickell) for contributions!","ref":"changelog.html#v3-1-0-2018-10-28","title":"v3.1.0 - 2018-10-28 - Changelog","type":"extras"},{"doc":"Major version bump as the behaviour of `OpenApiSpex.Plug.Cast` has changed (#39).\nTo enable requests that contain a body as well as path or query params, the result of casting the\nrequest body is now placed in the `Conn.body_params` field, instead of the combined `Conn.params` field.\n\nThis requires changing code such as Phoenix controller actions to from\n\n```elixir\ndef create(conn, %UserRequest{user: %User{name: name, email: email}}) do\n```\n\nto\n\n```elixir\n  def create(conn = %{body_params: %UserRequest{user: %User{name: name, email: email}}}, params) do\n```\n\n- Feature: A custom plug may be provided to render errors (#46)\n- Fix compiler warnings and improve CI process (#53)\n- Fix: Support casting GET requests without Content-Type header (#50, #49)\n- Open API Spex has been moved to the new `open-api-spex` Github organisation","ref":"changelog.html#v3-0-0-2018-10-25","title":"v3.0.0 - 2018-10-25 - Changelog","type":"extras"},{"doc":"- Docs: Update example application to include swagger generate mix task (#41)\n- Fix: Ignore charset in content-type header when looking up schema by content type. (#45)\n\nThanks to [dmt](https://github.com/dmt) and [fenollp](https://github.com/fenollp) for contributions!","ref":"changelog.html#v2-3-1-2018-09-09","title":"v2.3.1 - 2018-09-09 - Changelog","type":"extras"},{"doc":"- Feature: Validate string enum types. (#33)\n- Feature: Detect and report missing API spec in `OpenApiSpex.Plug.Cast` (#37)\n- Fix: Correct atom for parameter `style` field typespec (#36)\n\nThanks to [slavo2](https://github.com/slavo2) and [anagromataf](https://github.com/anagromataf) for\ncontributions!","ref":"changelog.html#v2-3-0-2018-08-05","title":"v2.3.0 - 2018-08-05 - Changelog","type":"extras"},{"doc":"- Feature: Support composite schemas in `OpenApiSpex.schema`\n\n  structs defined with `OpenApiSpex.schema` will include all properties defined in schemas\n  listed in `allOf`. See the `OpenApiSpex.Schema` docs for some examples.\n\n- Feature: Support composite and polymorphic schemas with `OpenApiSpex.cast/3`.\n  - `discriminator` is used to cast polymorphic shemas to a more specific schema.\n  - `allOf` will cast all properties in each included schema\n  - `oneOf` / `anyOf` will attempt to use each schema until a successful cast is made","ref":"changelog.html#v2-2-0-2018-07-07","title":"v2.2.0 - 2018-07-07 - Changelog","type":"extras"},{"doc":"- Fix: (#24, #25) Operations that define `parameters` and a `requestBody` schema can be validated.","ref":"changelog.html#v2-1-1-2018-06-12","title":"v2.1.1 - 2018-06-12 - Changelog","type":"extras"},{"doc":"- Feature: (#16) Error response from `OpenApiSpex.cast` when value contains unknown properties and schema declares `additionalProperties: false`.\n- Feature: (#20) Update swagger-ui to version 3.17.0.\n- Fix: (#17, #21, #22) Update typespecs for struct types.","ref":"changelog.html#v2-1-0-2018-06-08","title":"v2.1.0 - 2018-06-08 - Changelog","type":"extras"},{"doc":"Major version update following from API change in `OpenApiSpex.cast` and `OpenApiSpex.validate`.\nWhen casting/validating all parameters against an `OpenApiSpex.Operation`, the complete `Plug.Conn` struct must now be passed, where the combined params map was previously accepted.\nThis allows `OpenApiSpex.cast` / `OpenApiSpex.validate` to check that the parameters are being supplied in the expected location (query, path, body, header, cookie).\nIn version 2.0.0, only unexpected query parameters will cause a 422 response from `OpenApiSpex.Plug.Cast`, this may be extended in future versions to detect more invalid requests.\n\nThanks [cstaud](https://github.com/cstaud), [rutho](https://github.com/ThomasRueckert), [anagromataf](https://github.com/anagromataf) for contributions!\n\n- Change: (#9) swagger-ui updated to 3.13.4\n- Change (#9) Unexpected query parameters will produce an error response from `OpenApiSpex.Plug.Cast`\n- Change: (#9) `OpenApiSpex.cast/4` now requires a complete `Plug.Conn` struct when casting all parameters of an `OpenApiSpex.Operation`\n- Change: (#14) `OpenApiSpex.validate/4` now requires a complete `Plug.Conn` struct when validating all parameters of an `OpenApiSpex.Operation`\n- Fix: (#11) Support resolving list of schema modules in `oneOf`, `anyOf`, etc.\n- Fix: `OpenApiSpex.schema` macro allows defining schemas without any properties\n- Fix: type declarations better reflect when `nil` is allowed","ref":"changelog.html#v2-0-0-2018-06-06","title":"v2.0.0 - 2018-06-06 - Changelog","type":"extras"},{"doc":"- `additionalProperties` is now `nil` by default, was previously `true`","ref":"changelog.html#v1-1-4-2018-01-21","title":"v1.1.4 - 2018-01-21 - Changelog","type":"extras"},{"doc":"- Fix several bugs and make some minor enhancements to schema casting and validating.\n- Add sample application to enable end-to-end testing","ref":"changelog.html#v1-1-3-2017-10-15","title":"v1.1.3 - 2017-10-15 - Changelog","type":"extras"},{"doc":"Fix openapi version output in generated spec.","ref":"changelog.html#v1-1-2-2017-10-15","title":"v1.1.2 - 2017-10-15 - Changelog","type":"extras"},{"doc":"Update swagger-ui to version 3.3.2","ref":"changelog.html#v1-1-1-2017-10-15","title":"v1.1.1 - 2017-10-15 - Changelog","type":"extras"},{"doc":"Include path to invalid element in validation errors.\nEg: \"#/user/name: Value does not match pattern: [a-zA-Z][a-za-z0-9_]+\"","ref":"changelog.html#v1-1-0-2017-10-15","title":"v1.1.0 - 2017-10-15 - Changelog","type":"extras"},{"doc":"Cache API spec in application environment after first call to PutApiSpec plug","ref":"changelog.html#v1-0-1-2017-10-12","title":"v1.0.1 - 2017-10-12 - Changelog","type":"extras"},{"doc":"Initial release. This package is inspired by [phoenix_swagger](https://github.com/xerions/phoenix_swagger) but targets Open API Spec 3.0.","ref":"changelog.html#v1-0-0-2017-10-02","title":"v1.0.0 - 2017-10-02 - Changelog","type":"extras"},{"doc":"# Contributing","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"If you've found a bug or would like to discuss a new feature, start by [opening an issue](https://github.com/open-api-spex/open_api_spex/issues/new).\nWhere possible, please refer to the relevant sections of the Open API Specification 3.0 or JSON Schema Specification:\n\n- https://swagger.io/docs/specification/\n- https://github.com/OAI/OpenAPI-Specification/blob/OpenAPI.next/versions/3.0.0.md\n- https://json-schema.org/understanding-json-schema/","ref":"contributing.html#open-an-issue","title":"Open an issue - Contributing","type":"extras"},{"doc":"Link your pull request to the issue opened earlier, eg `fixes #123`.\nPlease be patient as maintainers are generally volunteering their time to support the project 🙂","ref":"contributing.html#send-a-pull-request","title":"Send a Pull Request - Contributing","type":"extras"},{"doc":"You can ask for help using OpenApiSpex by:\n\n- [Opening an issue](https://github.com/open-api-spex/open_api_spex/issues/new) - you may have run in to a bug or poorly documented feature!\n- Using the [open_api_spex slack channel](https://elixir-lang.slack.com/messages/CPEN5UW1X)\n- Using the [Elixir Forum thread](https://elixirforum.com/t/openapispex-openapi-swagger-3-0-for-plug-apis/15614)","ref":"contributing.html#get-help","title":"Get Help - Contributing","type":"extras"},{"doc":"To ship a release to Hex.pm, complete the following checklist:\n\n- Confirm the project builds and all tests pass on your machine `mix clean; mix test`\n- If possible, look for regressions by testing `master` against a project that uses `:open_api_spex`.\n- Confirm the docs build successfully and do not contain obvious formatting errors `mix docs; open doc/index.html`\n- Review the `CHANGELOG.md` file, adding a line for each pr / issue and a larger description for significant changes.\n- Update the `@version` attribute in `mix.exs`\n- Update the `Installation` section of the `README.md` file with the new version (for minor and major releases)\n- Commit and tag the `master` branch with the version and a leading `v`, eg: `v3.14.15`\n- Push master branch to `open_api_spex` repo\n- Push package to Hex: `mix hex.publish`\n- Add a release announcement to the [Elixir Forum thread](https://elixirforum.com/t/openapispex-openapi-swagger-3-0-for-plug-apis/15614)\n- Add a release announcement to the #open_api_spex channel in the Elixir Slack workspace","ref":"contributing.html#releasing-maintainers-only","title":"Releasing (Maintainers Only) - Contributing","type":"extras"},{"doc":"# Roadmap","ref":"roadmap.html","title":"Roadmap","type":"extras"},{"doc":"- Remove need for `json_render_error_v2: true` option for `CastAndValidate`\n- Remove `OpenApiSpex.Plug.Cast`, and rename `Cast2` to `Cast`.\n- Simplify interface for error rendering modules\n- Pass casted request params to `conn` without breaking contract with `Conn.t`\n- Remove `@derive` call in `OpenApiSpex.schema/1`","ref":"roadmap.html#version-4","title":"Version 4 - Roadmap","type":"extras"},{"doc":"Mozilla Public License, version 2.0\n\n1. Definitions\n\n1.1. \"Contributor\"\n\n     means each individual or legal entity that creates, contributes to the\n     creation of, or owns Covered Software.\n\n1.2. \"Contributor Version\"\n\n     means the combination of the Contributions of others (if any) used by a\n     Contributor and that particular Contributor's Contribution.\n\n1.3. \"Contribution\"\n\n     means Covered Software of a particular Contributor.\n\n1.4. \"Covered Software\"\n\n     means Source Code Form to which the initial Contributor has attached the\n     notice in Exhibit A, the Executable Form of such Source Code Form, and\n     Modifications of such Source Code Form, in each case including portions\n     thereof.\n\n1.5. \"Incompatible With Secondary Licenses\"\n     means\n\n     a. that the initial Contributor has attached the notice described in\n        Exhibit B to the Covered Software; or\n\n     b. that the Covered Software was made available under the terms of\n        version 1.1 or earlier of the License, but not also under the terms of\n        a Secondary License.\n\n1.6. \"Executable Form\"\n\n     means any form of the work other than Source Code Form.\n\n1.7. \"Larger Work\"\n\n     means a work that combines Covered Software with other material, in a\n     separate file or files, that is not Covered Software.\n\n1.8. \"License\"\n\n     means this document.\n\n1.9. \"Licensable\"\n\n     means having the right to grant, to the maximum extent possible, whether\n     at the time of the initial grant or subsequently, any and all of the\n     rights conveyed by this License.\n\n1.10. \"Modifications\"\n\n     means any of the following:\n\n     a. any file in Source Code Form that results from an addition to,\n        deletion from, or modification of the contents of Covered Software; or\n\n     b. any new file in Source Code Form that contains any Covered Software.\n\n1.11. \"Patent Claims\" of a Contributor\n\n      means any patent claim(s), including without limitation, method,\n      process, and apparatus claims, in any patent Licensable by such\n      Contributor that would be infringed, but for the grant of the License,\n      by the making, using, selling, offering for sale, having made, import,\n      or transfer of either its Contributions or its Contributor Version.\n\n1.12. \"Secondary License\"\n\n      means either the GNU General Public License, Version 2.0, the GNU Lesser\n      General Public License, Version 2.1, the GNU Affero General Public\n      License, Version 3.0, or any later versions of those licenses.\n\n1.13. \"Source Code Form\"\n\n      means the form of the work preferred for making modifications.\n\n1.14. \"You\" (or \"Your\")\n\n      means an individual or a legal entity exercising rights under this\n      License. For legal entities, \"You\" includes any entity that controls, is\n      controlled by, or is under common control with You. For purposes of this\n      definition, \"control\" means (a) the power, direct or indirect, to cause\n      the direction or management of such entity, whether by contract or\n      otherwise, or (b) ownership of more than fifty percent (50%) of the\n      outstanding shares or beneficial ownership of such entity.\n\n\n2. License Grants and Conditions\n\n2.1. Grants\n\n     Each Contributor hereby grants You a world-wide, royalty-free,\n     non-exclusive license:\n\n     a. under intellectual property rights (other than patent or trademark)\n        Licensable by such Contributor to use, reproduce, make available,\n        modify, display, perform, distribute, and otherwise exploit its\n        Contributions, either on an unmodified basis, with Modifications, or\n        as part of a Larger Work; and\n\n     b. under Patent Claims of such Contributor to make, use, sell, offer for\n        sale, have made, import, and otherwise transfer either its\n        Contributions or its Contributor Version.\n\n2.2. Effective Date\n\n     The licenses granted in Section 2.1 with respect to any Contribution\n     become effective for each Contribution on the date the Contributor first\n     distributes such Contribution.\n\n2.3. Limitations on Grant Scope\n\n     The licenses granted in this Section 2 are the only rights granted under\n     this License. No additional rights or licenses will be implied from the\n     distribution or licensing of Covered Software under this License.\n     Notwithstanding Section 2.1(b) above, no patent license is granted by a\n     Contributor:\n\n     a. for any code that a Contributor has removed from Covered Software; or\n\n     b. for infringements caused by: (i) Your and any other third party's\n        modifications of Covered Software, or (ii) the combination of its\n        Contributions with other software (except as part of its Contributor\n        Version); or\n\n     c. under Patent Claims infringed by Covered Software in the absence of\n        its Contributions.\n\n     This License does not grant any rights in the trademarks, service marks,\n     or logos of any Contributor (except as may be necessary to comply with\n     the notice requirements in Section 3.4).\n\n2.4. Subsequent Licenses\n\n     No Contributor makes additional grants as a result of Your choice to\n     distribute the Covered Software under a subsequent version of this\n     License (see Section 10.2) or under the terms of a Secondary License (if\n     permitted under the terms of Section 3.3).\n\n2.5. Representation\n\n     Each Contributor represents that the Contributor believes its\n     Contributions are its original creation(s) or it has sufficient rights to\n     grant the rights to its Contributions conveyed by this License.\n\n2.6. Fair Use\n\n     This License is not intended to limit any rights You have under\n     applicable copyright doctrines of fair use, fair dealing, or other\n     equivalents.\n\n2.7. Conditions\n\n     Sections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted in\n     Section 2.1.\n\n\n3. Responsibilities\n\n3.1. Distribution of Source Form\n\n     All distribution of Covered Software in Source Code Form, including any\n     Modifications that You create or to which You contribute, must be under\n     the terms of this License. You must inform recipients that the Source\n     Code Form of the Covered Software is governed by the terms of this\n     License, and how they can obtain a copy of this License. You may not\n     attempt to alter or restrict the recipients' rights in the Source Code\n     Form.\n\n3.2. Distribution of Executable Form\n\n     If You distribute Covered Software in Executable Form then:\n\n     a. such Covered Software must also be made available in Source Code Form,\n        as described in Section 3.1, and You must inform recipients of the\n        Executable Form how they can obtain a copy of such Source Code Form by\n        reasonable means in a timely manner, at a charge no more than the cost\n        of distribution to the recipient; and\n\n     b. You may distribute such Executable Form under the terms of this\n        License, or sublicense it under different terms, provided that the\n        license for the Executable Form does not attempt to limit or alter the\n        recipients' rights in the Source Code Form under this License.\n\n3.3. Distribution of a Larger Work\n\n     You may create and distribute a Larger Work under terms of Your choice,\n     provided that You also comply with the requirements of this License for\n     the Covered Software. If the Larger Work is a combination of Covered\n     Software with a work governed by one or more Secondary Licenses, and the\n     Covered Software is not Incompatible With Secondary Licenses, this\n     License permits You to additionally distribute such Covered Software\n     under the terms of such Secondary License(s), so that the recipient of\n     the Larger Work may, at their option, further distribute the Covered\n     Software under the terms of either this License or such Secondary\n     License(s).\n\n3.4. Notices\n\n     You may not remove or alter the substance of any license notices\n     (including copyright notices, patent notices, disclaimers of warranty, or\n     limitations of liability) contained within the Source Code Form of the\n     Covered Software, except that You may alter any license notices to the\n     extent required to remedy known factual inaccuracies.\n\n3.5. Application of Additional Terms\n\n     You may choose to offer, and to charge a fee for, warranty, support,\n     indemnity or liability obligations to one or more recipients of Covered\n     Software. However, You may do so only on Your own behalf, and not on\n     behalf of any Contributor. You must make it absolutely clear that any\n     such warranty, support, indemnity, or liability obligation is offered by\n     You alone, and You hereby agree to indemnify every Contributor for any\n     liability incurred by such Contributor as a result of warranty, support,\n     indemnity or liability terms You offer. You may include additional\n     disclaimers of warranty and limitations of liability specific to any\n     jurisdiction.\n\n4. Inability to Comply Due to Statute or Regulation\n\n   If it is impossible for You to comply with any of the terms of this License\n   with respect to some or all of the Covered Software due to statute,\n   judicial order, or regulation then You must: (a) comply with the terms of\n   this License to the maximum extent possible; and (b) describe the\n   limitations and the code they affect. Such description must be placed in a\n   text file included with all distributions of the Covered Software under\n   this License. Except to the extent prohibited by statute or regulation,\n   such description must be sufficiently detailed for a recipient of ordinary\n   skill to be able to understand it.\n\n5. Termination\n\n5.1. The rights granted under this License will terminate automatically if You\n     fail to comply with any of its terms. However, if You become compliant,\n     then the rights granted under this License from a particular Contributor\n     are reinstated (a) provisionally, unless and until such Contributor\n     explicitly and finally terminates Your grants, and (b) on an ongoing\n     basis, if such Contributor fails to notify You of the non-compliance by\n     some reasonable means prior to 60 days after You have come back into\n     compliance. Moreover, Your grants from a particular Contributor are\n     reinstated on an ongoing basis if such Contributor notifies You of the\n     non-compliance by some reasonable means, this is the first time You have\n     received notice of non-compliance with this License from such\n     Contributor, and You become compliant prior to 30 days after Your receipt\n     of the notice.\n\n5.2. If You initiate litigation against any entity by asserting a patent\n     infringement claim (excluding declaratory judgment actions,\n     counter-claims, and cross-claims) alleging that a Contributor Version\n     directly or indirectly infringes any patent, then the rights granted to\n     You by any and all Contributors for the Covered Software under Section\n     2.1 of this License shall terminate.\n\n5.3. In the event of termination under Sections 5.1 or 5.2 above, all end user\n     license agreements (excluding distributors and resellers) which have been\n     validly granted by You or Your distributors under this License prior to\n     termination shall survive termination.\n\n6. Disclaimer of Warranty\n\n   Covered Software is provided under this License on an \"as is\" basis,\n   without warranty of any kind, either expressed, implied, or statutory,\n   including, without limitation, warranties that the Covered Software is free\n   of defects, merchantable, fit for a particular purpose or non-infringing.\n   The entire risk as to the quality and performance of the Covered Software\n   is with You. Should any Covered Software prove defective in any respect,\n   You (not any Contributor) assume the cost of any necessary servicing,\n   repair, or correction. This disclaimer of warranty constitutes an essential\n   part of this License. No use of  any Covered Software is authorized under\n   this License except under this disclaimer.\n\n7. Limitation of Liability\n\n   Under no circumstances and under no legal theory, whether tort (including\n   negligence), contract, or otherwise, shall any Contributor, or anyone who\n   distributes Covered Software as permitted above, be liable to You for any\n   direct, indirect, special, incidental, or consequential damages of any\n   character including, without limitation, damages for lost profits, loss of\n   goodwill, work stoppage, computer failure or malfunction, or any and all\n   other commercial damages or losses, even if such party shall have been\n   informed of the possibility of such damages. This limitation of liability\n   shall not apply to liability for death or personal injury resulting from\n   such party's negligence to the extent applicable law prohibits such\n   limitation. Some jurisdictions do not allow the exclusion or limitation of\n   incidental or consequential damages, so this exclusion and limitation may\n   not apply to You.\n\n8. Litigation\n\n   Any litigation relating to this License may be brought only in the courts\n   of a jurisdiction where the defendant maintains its principal place of\n   business and such litigation shall be governed by laws of that\n   jurisdiction, without reference to its conflict-of-law provisions. Nothing\n   in this Section shall prevent a party's ability to bring cross-claims or\n   counter-claims.\n\n9. Miscellaneous\n\n   This License represents the complete agreement concerning the subject\n   matter hereof. If any provision of this License is held to be\n   unenforceable, such provision shall be reformed only to the extent\n   necessary to make it enforceable. Any law or regulation which provides that\n   the language of a contract shall be construed against the drafter shall not\n   be used to construe this License against a Contributor.\n\n\n10. Versions of the License\n\n10.1. New Versions\n\n      Mozilla Foundation is the license steward. Except as provided in Section\n      10.3, no one other than the license steward has the right to modify or\n      publish new versions of this License. Each version will be given a\n      distinguishing version number.\n\n10.2. Effect of New Versions\n\n      You may distribute the Covered Software under the terms of the version\n      of the License under which You originally received the Covered Software,\n      or under the terms of any subsequent version published by the license\n      steward.\n\n10.3. Modified Versions\n\n      If you create software not governed by this License, and you want to\n      create a new license for such software, you may create and use a\n      modified version of this License if you rename the license and remove\n      any references to the name of the license steward (except to note that\n      such modified license differs from this License).\n\n10.4. Distributing Source Code Form that is Incompatible With Secondary\n      Licenses If You choose to distribute Source Code Form that is\n      Incompatible With Secondary Licenses under the terms of this version of\n      the License, the notice described in Exhibit B of this License must be\n      attached.\n\nExhibit A - Source Code Form License Notice\n\n      This Source Code Form is subject to the\n      terms of the Mozilla Public License, v.\n      2.0. If a copy of the MPL was not\n      distributed with this file, You can\n      obtain one at\n      http://mozilla.org/MPL/2.0/.\n\nIf it is not possible or desirable to put the notice in a particular file,\nthen You may include the notice in a location (such as a LICENSE file in a\nrelevant directory) where a recipient would be likely to look for such a\nnotice.\n\nYou may add additional accurate notices of copyright ownership.\n\nExhibit B - \"Incompatible With Secondary Licenses\" Notice\n\n      This Source Code Form is \"Incompatible\n      With Secondary Licenses\", as defined by\n      the Mozilla Public License, v. 2.0.","ref":"license.html","title":"License","type":"extras"},{"doc":"# Open API Spex\n\n[![Elixir CI](https://github.com/open-api-spex/open_api_spex/actions/workflows/elixir.yml/badge.svg)](https://github.com/open-api-spex/open_api_spex/actions/workflows/elixir.yml)\n[![Module Version](https://img.shields.io/hexpm/v/open_api_spex.svg)](https://hex.pm/packages/open_api_spex)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/open_api_spex/)\n[![Total Download](https://img.shields.io/hexpm/dt/open_api_spex.svg)](https://hex.pm/packages/open_api_spex)\n[![License](https://img.shields.io/hexpm/l/open_api_spex.svg)](https://github.com/open-api-spex/open_api_spex/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/open-api-spex/open_api_spex.svg)](https://github.com/open-api-spex/open_api_spex/commits/master)\n\nLeverage Open API Specification 3 (formerly Swagger) to document, test, validate and explore your Plug and Phoenix APIs.\n\n- Generate and serve a JSON Open API Spec document from your code\n- Use the spec to cast request params to well defined schema structs\n- Validate params against schemas, eliminate bad requests before they hit your controllers\n- Validate responses against schemas in tests, ensuring your docs are accurate and reliable\n- Explore the API interactively with [SwaggerUI](https://swagger.io/swagger-ui/)\n\nFull documentation available on [HexDocs](https://hexdocs.pm/open_api_spex/).","ref":"readme.html","title":"Open API Spex","type":"extras"},{"doc":"The package can be installed by adding `:open_api_spex` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:open_api_spex, \"~> 3.21\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Open API Spex","type":"extras"},{"doc":"","ref":"readme.html#generate-spec","title":"Generate Spec - Open API Spex","type":"extras"},{"doc":"Start by adding an `ApiSpec` module to your application to populate an `OpenApiSpex.OpenApi` struct.\n\n```elixir\ndefmodule MyAppWeb.ApiSpec do\n  alias OpenApiSpex.{Components, Info, OpenApi, Paths, Server}\n  alias MyAppWeb.{Endpoint, Router}\n  @behaviour OpenApi\n\n  @impl OpenApi\n  def spec do\n    %OpenApi{\n      servers: [\n        # Populate the Server info from a phoenix endpoint\n        Server.from_endpoint(Endpoint)\n      ],\n      info: %Info{\n        title: \"My App\",\n        version: \"1.0\"\n      },\n      # Populate the paths from a phoenix router\n      paths: Paths.from_router(Router)\n    }\n    |> OpenApiSpex.resolve_schema_modules() # Discover request/response schemas from path specs\n  end\nend\n```\n\nOr you can use your application's spec values in the `info:` key.\n\n```elixir\ninfo: %Info{\n  title: to_string(Application.spec(:my_app, :description)),\n  version: to_string(Application.spec(:my_app, :vsn))\n}\n```","ref":"readme.html#main-spec","title":"Main Spec - Open API Spex","type":"extras"},{"doc":"In case your API requires authorization you can add security schemes as part of the components in the main spec.\n\n```elixir\ncomponents: %Components{\n  securitySchemes: %{\"authorization\" => %SecurityScheme{type: \"http\", scheme: \"bearer\"}}\n}\n```\n\nOnce the security scheme is defined you can declare it. Please note that the key below matches the one defined in the security scheme, in the our example, `\"authorization\"`.\n\n```elixir\nsecurity: [%{\"authorization\" => []}]\n```\n\nIf you require authorization for all endpoints you can declare the `security` in the main spec. In case you need authorization only for specific endpoints, or if you are using more than one security scheme, you can declare it as part of each operation.\n\nTo learn more about the different security schemes please the check the [official documentation](https://swagger.io/docs/specification/authentication/).","ref":"readme.html#authorization","title":"Authorization - Open API Spex","type":"extras"},{"doc":"For each plug (controller) that will handle API requests, operations need\nto be defined that the plug/controller will handle.\n\n```elixir\ndefmodule MyAppWeb.UserController do\n  use MyAppWeb, :controller\n  use OpenApiSpex.ControllerSpecs\n\n  alias MyAppWeb.Schemas.{UserParams, UserResponse}\n\n  tags [\"users\"]\n  security [%{}, %{\"petstore_auth\" => [\"write:users\", \"read:users\"]}]\n\n  operation :update,\n    summary: \"Update user\",\n    parameters: [\n      id: [in: :path, description: \"User ID\", type: :integer, example: 1001]\n    ],\n    request_body: {\"User params\", \"application/json\", UserParams},\n    responses: [\n      ok: {\"User response\", \"application/json\", UserResponse}\n    ]\n\n  def update(conn, %{\"id\" => id}) do\n    json(conn, %{\n      data: %{\n        id: id,\n        name: \"joe user\",\n        email: \"joe@gmail.com\"\n      }\n    })\n  end\nend\n```\n\nNote: In order to prevent Elixir Formatter from automatically adding parentheses to the `ControllerSpecs` macro\ncall arguments, add `:open_api_spex` to the `import_deps` list in `.formatter.exs`:\n\n.formatter.exs:\n\n```elixir\n[\n  import_deps: [:open_api_spex]\n]\n```\n\nFor further information about defining operations, see `OpenApiSpex.ControllerSpecs`.\n\nIf you need to omit the spec for some action then pass false to the\nsecond argument of `operation/2` for the action:\n\n```elixir\noperation :create, false\n```\n\nEach definition in a controller action or plug operation is converted\nto an `%OpenApiSpex.Operation{}` struct. The definitions are read\nby your application's `ApiSpec` module, which in turn is\ncalled from the `OpenApiSpex.Plug.PutApiSpex` plug on each request.\nThe definitions data is cached, so it does not actually extract the definitions on each request.\n\nNote that the names of the OpenAPI fields follow `snake_case` naming convention instead of\nOpenAPI's (and JSON Schema's) `camelCase` convention.","ref":"readme.html#operations","title":"Operations - Open API Spex","type":"extras"},{"doc":"#### %Operation{}\n\nIf ControllerSpecs-style operation specs don't provide the flexibility you need, the `%Operation{}` struct\nand related structs can be used instead. See the\n[example user controller that uses `%Operation{}` structs](https://github.com/open-api-spex/open_api_spex/blob/master/examples/phoenix_app/lib/phoenix_app_web/controllers/user_controller_with_struct_specs.ex).\n\nFor examples of other action operations, see the\n[example web app](https://github.com/open-api-spex/open_api_spex/blob/master/examples/phoenix_app/lib/phoenix_app_web/controllers/user_controller.ex).","ref":"readme.html#alternatives-to-controllerspecs-style-operation-specs","title":"Alternatives to ControllerSpecs-style Operation Specs - Open API Spex","type":"extras"},{"doc":"Next, declare JSON schema modules for the request and response bodies.\nIn each schema module, call `OpenApiSpex.schema/1`, passing the schema definition. The schema must\nhave keys described in `OpenApiSpex.Schema.t`. This will define a `%OpenApiSpex.Schema{}` struct.\nThis struct is made available from the `schema/0` public function, which is generated by `OpenApiSpex.schema/1`.\n\nYou may optionally have the data described by the schema turned into a struct linked to the JSON schema by adding `\"x-struct\": __MODULE__`\nto the schema.\n\n```elixir\ndefmodule MyAppWeb.Schemas do\n  alias OpenApiSpex.Schema\n\n  defmodule User do\n    require OpenApiSpex\n\n    OpenApiSpex.schema(%{\n      # The title is optional. It defaults to the last section of the module name.\n      # So the derived title for MyApp.User is \"User\".\n      title: \"User\",\n      description: \"A user of the app\",\n      type: :object,\n      properties: %{\n        id: %Schema{type: :integer, description: \"User ID\"},\n        name: %Schema{type: :string, description: \"User name\", pattern: ~r/[a-zA-Z][a-zA-Z0-9_]+/},\n        email: %Schema{type: :string, description: \"Email address\", format: :email},\n        birthday: %Schema{type: :string, description: \"Birth date\", format: :date},\n        inserted_at: %Schema{\n          type: :string,\n          description: \"Creation timestamp\",\n          format: :\"date-time\"\n        },\n        updated_at: %Schema{type: :string, description: \"Update timestamp\", format: :\"date-time\"}\n      },\n      required: [:name, :email],\n      example: %{\n        \"id\" => 123,\n        \"name\" => \"Joe User\",\n        \"email\" => \"joe@gmail.com\",\n        \"birthday\" => \"1970-01-01T12:34:55Z\",\n        \"inserted_at\" => \"2017-09-12T12:34:55Z\",\n        \"updated_at\" => \"2017-09-13T10:11:12Z\"\n      }\n    })\n  end\n\n  defmodule UserResponse do\n    require OpenApiSpex\n\n    OpenApiSpex.schema(%{\n      title: \"UserResponse\",\n      description: \"Response schema for single user\",\n      type: :object,\n      properties: %{\n        data: User\n      },\n      example: %{\n        \"data\" => %{\n          \"id\" => 123,\n          \"name\" => \"Joe User\",\n          \"email\" => \"joe@gmail.com\",\n          \"birthday\" => \"1970-01-01T12:34:55Z\",\n          \"inserted_at\" => \"2017-09-12T12:34:55Z\",\n          \"updated_at\" => \"2017-09-13T10:11:12Z\"\n        }\n      }\n    })\n  end\nend\n```\n\nFor more examples of schema definitions, see the\n[sample Phoenix app](https://github.com/open-api-spex/open_api_spex/blob/master/examples/phoenix_app/lib/phoenix_app_web/schemas.ex).","ref":"readme.html#schemas","title":"Schemas - Open API Spex","type":"extras"},{"doc":"To serve the API spec from your application, first add the `OpenApiSpex.Plug.PutApiSpec` plug somewhere in the pipeline.\n\n```elixir\npipeline :api do\n  plug OpenApiSpex.Plug.PutApiSpec, module: MyAppWeb.ApiSpec\nend\n```\n\nNow the spec will be available for use in downstream plugs.\nThe `OpenApiSpex.Plug.RenderSpec` plug will render the spec as JSON:\n\n```elixir\nscope \"/api\" do\n  pipe_through :api\n  resources \"/users\", MyAppWeb.UserController, only: [:create, :index, :show]\n  get \"/openapi\", OpenApiSpex.Plug.RenderSpec, []\nend\n```\n\nIn development, to ensure the rendered spec is refreshed, you should disable caching with:\n\n```elixir\n# config/dev.exs\nconfig :open_api_spex, :cache_adapter, OpenApiSpex.Plug.NoneCache\n```","ref":"readme.html#serve-the-spec","title":"Serve the Spec - Open API Spex","type":"extras"},{"doc":"You can write the swagger file to disk using the following Mix task and optionally, for your\nconvenience, create a direct alias:\n\n```shell\nmix openapi.spec.json --spec MyAppWeb.ApiSpec\nmix openapi.spec.yaml --spec MyAppWeb.ApiSpec\n```\n\nInvoking this task starts the application by default. This can be\ndisabled with the `--start-app=false` option.\n\nPlease replace any calls to [OpenApiSpex.Server.from_endpoint](https://hexdocs.pm/open_api_spex/OpenApiSpex.Server.html#from_endpoint/1) with a `%OpenApiSpex.Server{}` struct like below:\n\n```elixir\n  %OpenApi{\n    info: %Info{\n      title: \"Phoenix App\",\n      version: \"1.0\"\n    },\n    # Replace this 👇\n    servers: [OpenApiSpex.Server.from_endpoint(MyAppWeb.Endpoint)],\n    # With this 👇\n    servers: [%OpenApiSpex.Server{url: \"https://yourapi.example.com\"}],\n  }\n```\n\nNOTE: You need to add the `ymlr` dependency to write swagger file in YAML format:\n\n```elixir\n\ndef deps do\n  [\n    {:ymlr, \"~> 2.0\"}\n  ]\nend\n```\n\nFor more options read the [docs](https://hexdocs.pm/open_api_spex/Mix.Tasks.Openapi.Spec.Json.html).\n\n```shell\nmix help openapi.spec.json\nmix help openapi.spec.yaml\n```","ref":"readme.html#generating-the-spec","title":"Generating the Spec - Open API Spex","type":"extras"},{"doc":"Once your API spec is available through a route (see [\"Serve the Spec\"](#serve-the-spec)), the `OpenApiSpex.Plug.SwaggerUI` plug can be used to\nserve a SwaggerUI interface. The `path:` plug option must be supplied to give the path to the API spec.\n\nAll JavaScript and CSS assets are sourced from cdnjs.cloudflare.com, rather than vendoring into this package.\n\n```elixir\nscope \"/\" do\n  pipe_through :browser # Use the default browser stack\n\n  get \"/\", MyAppWeb.PageController, :index\n  get \"/swaggerui\", OpenApiSpex.Plug.SwaggerUI, path: \"/api/openapi\"\nend\n\nscope \"/api\" do\n  pipe_through :api\n\n  resources \"/users\", MyAppWeb.UserController, only: [:create, :index, :show]\n  get \"/openapi\", OpenApiSpex.Plug.RenderSpec, []\nend\n```","ref":"readme.html#serve-swagger-ui","title":"Serve Swagger UI - Open API Spex","type":"extras"},{"doc":"> :warning: This functionality currently converts Strings into Atoms, which makes it potentially [vulnerable to DoS attacks](https://til.hashrocket.com/posts/gkwwfy9xvw-converting-strings-to-atoms-safely). We recommend that you load Open API Schemas from _known files_ during application startup and _not dynamically from external sources at runtime_.\n\nOpenApiSpex has functionality to import an existing schema, casting it into an `%OpenApi{}` struct. This means you can load a schema that is JSON or YAML encoded. See the example below:\n\n```elixir\n# Importing an existing JSON encoded schema\nopen_api_spec_from_json = \"encoded_schema.json\"\n  |> File.read!()\n  |> Jason.decode!()\n  |> OpenApiSpex.OpenApi.Decode.decode()\n\n# Importing an existing YAML encoded schema\nopen_api_spec_from_yaml = \"encoded_schema.yaml\"\n  |> YamlElixir.read_all_from_file!()\n  |> List.first()\n  |> OpenApiSpex.OpenApi.Decode.decode()\n```\n\nYou can then use the loaded spec to with `OpenApiSpex.cast_and_validate/3`, like:\n\n```elixir\n{:ok, _} = OpenApiSpex.cast_and_validate(\n  open_api_spec_from_json, # or open_api_spec_from_yaml\n  spec.paths[\"/some_path\"].post,\n  test_conn\n)\n```","ref":"readme.html#importing-an-existing-schema-file","title":"Importing an existing schema file - Open API Spex","type":"extras"},{"doc":"OpenApiSpex can automatically validate requests before they reach the controller action function. Or if you prefer,\nyou can explicitly call on OpenApiSpex to cast and validate the params within the controller action.\nSee `OpenApiSpex.cast_value/3` for the latter.\n\nThe rest of this section describes implicit casting and validating the request before it reaches your controller action.\n\nFirst, the `plug OpenApiSpex.Plug.PutApiSpec` needs to be called in the Router, as described above.\n\nAdd the `OpenApiSpex.Plug.CastAndValidate` plug to a controller to validate request parameters and to cast to Elixir types defined by the operation schema.\n\n```elixir\n# Phoenix\nplug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true\n# Plug\nplug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true, operation_id: \"UserController.create\"\n```\n\nThe `json_render_error_v2: true` is a work-around for a bug in the format of the default error renderer.\nIt will be not needed in version 4.0.\n\nFor Phoenix apps, the `operation_id` can be inferred from the contents of `conn.private`.\n\nThe data shape of the default error renderer follows the JSON:API spec for error responses. For\nconvenience, the `OpenApiSpex.JsonErrorResponse` schema module is available that specifies\nthe shape, and it can be used in your API specs.\n\nExample usage of `CastAndValidate` in a Phoenix controller:\n\n```elixir\ndefmodule MyAppWeb.UserController do\n  use MyAppWeb, :controller\n  use OpenApiSpex.ControllerSpecs\n\n  alias MyAppWeb.Schemas.{UserParams, UserResponse}\n\n  plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true\n\n  operation :update,\n    summary: \"Update user\",\n    description: \"Updates with the given params.\\nThis is another line of text in the description.\",\n    parameters: [\n      id: [in: :path, type: :integer, description: \"user ID\"],\n      vsn: [in: :query, type: :integer, description: \"API version number\"],\n      \"api-version\": [in: :header, type: :integer, description: \"API version number\"]\n    ],\n    request_body: {\"The user attributes\", \"application/json\", UserParams},\n    responses: %{\n      201 => {\"User\", \"application/json\", UserResponse},\n      422 => OpenApiSpex.JsonErrorResponse.response()\n    }\n  def update(\n        conn = %{\n          body_params: %UserParams{\n            name: name,\n            email: email,\n            birthday: %Date{} = birthday\n          }\n        },\n        %{id: id}\n      ) do\n    # conn.body_params cast to UserRequest struct\n    # conn.params combines path params, query params and header params\n    # conn.params.id cast to integer\n    # conn.params.vsn cast to integer\n    # conn.params[:\"api-version\"] cast to integer\n    # params is the same as conn.params\n    # params.id cast to integer\n\n    # Note: Using pattern-matching in the action function's arguments can\n    # cause Dialyzer to complain. This is because Dialyzer expects the\n    # `conn` and `params` arguments to have string keys, not atom keys.\n    # To resolve this, fetch the `:body_params` with\n    # `body_params = Map.get(conn, :body_params)`.\n  end\nend\n```\n\nNow the client will receive a 422 response whenever the request fails to meet the validation rules from the api spec.\n\nThe response body will include the validation error message:\n\n```json\n{\n  \"errors\": [\n    {\n      \"detail\": \"Invalid format. Expected :date\",\n      \"source\": {\n        \"pointer\": \"/data/birthday\"\n      },\n      \"title\": \"Invalid value\"\n    }\n  ]\n}\n```\n\nIf you would like a different response JSON shape, create a plug module to shape the response,\nand pass it to `CastAndValidate`:\n\n```elixir\nplug OpenApiSpex.Plug.CastAndValidate, render_error: MyErrorRendererPlug\n```\n\n```elixir\ndefmodule MyErrorRendererPlug do\n  @behaviour Plug\n\n  alias Plug.Conn\n  alias OpenApiSpex.OpenApi\n\n  @impl Plug\n  def init(errors), do: errors\n\n  @impl Plug\n  def call(conn, errors) when is_list(errors) do\n    response = %{\n      errors: Enum.map(errors, &to_string/1)\n    }\n\n    json = OpenApi.json_encoder().encode!(response)\n\n    conn\n    |> Conn.put_resp_content_type(\"application/json\")\n    |> Conn.send_resp(422, json)\n  end\nend\n```","ref":"readme.html#validating-and-casting-params","title":"Validating and Casting Params - Open API Spex","type":"extras"},{"doc":"OpenApiSpex can generate example data from specs. This has a similar result as\nSwaggerUI when it generates example requests or responses for an endpoint.\nThis is a convenient way to generate test data for controller/plug tests.\n\n```elixir\nuse MyAppWeb.ConnCase\n\ntest \"create/2\", %{conn: conn} do\n  request_body = OpenApiSpex.Schema.example(MyAppWeb.Schemas.UserRequest.schema())\n\n  json =\n    conn\n    |> post(user_path(conn), request_body)\n    |> json_response(200)\nend\n```","ref":"readme.html#generate-examples","title":"Generate Examples - Open API Spex","type":"extras"},{"doc":"As schemas evolve, you may want to confirm that the examples given match the schemas.\nUse the `OpenApiSpex.TestAssertions` module to assert on schema validations.\n\n```elixir\nuse ExUnit.Case\nimport OpenApiSpex.TestAssertions\n\ntest \"UsersResponse example matches schema\" do\n  api_spec = MyAppWeb.ApiSpec.spec()\n  schema = MyAppWeb.Schemas.UsersResponse.schema()\n  assert_schema(schema.example, \"UsersResponse\", api_spec)\nend\n```","ref":"readme.html#validate-examples","title":"Validate Examples - Open API Spex","type":"extras"},{"doc":"API responses can be tested against schemas using `OpenApiSpex.TestAssertions` also:\n\n```elixir\nuse MyAppWeb.ConnCase\nimport OpenApiSpex.TestAssertions\n\ntest \"UserController produces a UsersResponse\", %{conn: conn} do\n  json =\n    conn\n    |> get(user_path(conn, :index))\n    |> json_response(200)\n\n  api_spec = MyAppWeb.ApiSpec.spec()\n  assert_schema(json, \"UsersResponse\", api_spec)\nend\n```","ref":"readme.html#validate-responses","title":"Validate Responses - Open API Spex","type":"extras"},{"doc":"Copyright (c) 2017 Michael Buhot\n\nLicensed under the Mozilla Public License, Version 2.0, which can be found in [LICENSE](./LICENSE).","ref":"readme.html#copyright-and-license","title":"Copyright and License - Open API Spex","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}